# htmlstuff.pl - html-related common routines
# $Id: htmlstuff.pl.in,v 1.19 2001/09/10 10:57:50 remstats Exp $

# Copyright 1999, 2000, 2001 (c) Thomas Erskine <thomas.erskine@sourceworks.com>
# See the COPYRIGHT file with the distribution.

# - - -   Version History   - - -

use strict;

# $Revision: 1.19 $

# &init_indices();
# $html .= &html_header( $title, $thisis, %indices);
# $html .= &toolbar( $host [,$ip]);
# $html .= &html_footer;
# $html .= &status_header( $host [,$ip]);
# $html .= &rrd_status_header( $host, $realrrd, $wildrrd, $fixedrrd, $graph);
# &sec_to_dhms( $secs);
# &make_rrdcgi_graph( $dir, $prefix, $host, $realrrd, $graph, $graphtime, $alttext);
# &make_custom_graph( $dir, $prefix, $customgraph, $graphtime);

#------------------------------------------------------------ init_indices ---
sub init_indices {
	my %indices;

	%indices =
		($main::config{HTML}{QUICKINDEX} =>	'quick-index.cgi',
#		$main::config{HTML}{OVERALLINDEX} =>	'overall-index.cgi', 
		$main::config{HTML}{RRDINDEX} =>	'rrd-index.cgi', 
		$main::config{HTML}{PINGINDEX} =>	'ping-index.cgi',
		$main::config{HTML}{ALERTREPORT} => 	'alert.cgi',
		$main::config{HTML}{ALERTINDEX} => 	'datapage.cgi?alert-index',
		$main::config{HTML}{CUSTOMINDEX} =>	'CUSTOM/index.cgi',
		$main::config{HTML}{VIEWINDEX} =>	'view-index.cgi',
		$main::config{HTML}{LOGREPORT} => 	'showlog.cgi'
	);
%indices;
}

#------------------------------------------------------------- html_header ---
sub html_header {
	my $title = shift @_;
	my $thisis = shift @_;
	my %indices = @_ if (defined $_[0]);
	my ($html, $background, $refresh, $author, $printed_index, $index, $fixed,
		$prefix, $refreshtime);

	$background = $main::config{BACKGROUND};
	if (defined $background) { $background = ' '. $background; }
	else { $background = ''; }

	$refreshtime = $refresh = $main::config{HTMLREFRESH};
	if (defined $refresh) {
		$refresh = "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$refresh\">";
	}
	else { $refresh = ''; }
	$author = 'thomas.erskine@sourceworks.com';

	if (defined $main::config{LOGOURL}) {
		if (defined $main::config{HOMEURL}) {
			$prefix = '<A HREF="'. $main::config{HOMEURL} .'">'.
				'<IMG SRC="'. $main::config{LOGOURL} .'" BORDER=0 VALIGN=CENTER></A>';
		}
		else {
			$prefix = '<IMG SRC="'. $main::config{LOGOURL} .'" BORDER=0 VALIGN=CENTER>';
		}
	}
	else { $prefix = ''; }

	$html = <<"EOD_HEADER";
<HTML>
<HEAD>
<TITLE>Remstats - $title</TITLE>
<LINK REV=MADE HREF="mailto:$author">
<LINK REL="stylesheet" TYPE="text/css" HREF="$main::config{HTMLURL}/default.css">
<META HTTP-EQUIV="description" CONTENT="$title">
<META HTTP-EQUIV="keywords" CONTENT="remstats,rrdtool,$title">
$refresh
</HEAD>

<!-- written by remstats 1.00a4 $main::prog version $main::version -->

<BODY$background>
<RRD::GOODFOR -$refreshtime>
<DIV CLASS="TITLE">
	<SPAN CLASS="TITLE">$prefix</SPAN>
	<SPAN CLASS="TITLE">Remstats - $title</SPAN>
</DIV>
EOD_HEADER

# Show the index-line, if the possibilities were provided
	$printed_index = 0;
	foreach $index (sort keys %indices) {
		next unless (defined $indices{$index});
		unless ($printed_index) {
			$printed_index++;
			$html .= "<HR>\n<B>$main::config{HTML}{INDICES}</B>: \n";
		}
		($fixed = $index) =~ s# #&nbsp;#g;
		if ($index eq $thisis) {
			$html .= $fixed ."\n";
		}
		else {
			$html .= <<"EOD_INDEX";
$main::config{HTML}{INDEXPREFIX}<A CLASS="BUT" HREF="$main::config{HTMLURL}/$indices{$index}">$fixed</A>$main::config{HTML}{INDEXSUFFIX}
EOD_INDEX
		}
	}
	# Set up the MOTD file
	unless (-f $main::config{HTML}{MOTDFILE} or -l $main::config{HTML}{MOTDFILE}) {
		open (MOTD, ">$main::config{HTML}{MOTDFILE}") or do {
			&error("can't touch MOTD file ($main::config{HTML}{MOTDFILE})");
		close(MOTD);
        };
	}
	$html .= "<HR>\n<RRD::INCLUDE ". $main::config{HTML}{MOTDFILE} .">\n";

	if ($printed_index) { $html .= "\n"; }
	&debug("indices: $html") if ($main::debug>1);
$html;
}

#--------------------------------------------------------------- toolbar ---
sub toolbar {
	my ($host, $ip) = @_;
	my ($html, $tool, $thishtml, $fixed, @tools);

	if (defined $main::config{HOST}{$host}{TOOLS}) {
		@tools = @{$main::config{HOST}{$host}{TOOLS}};
	}
	else { @tools = @{$main::config{HTML}{DEFAULTTOOLS}}; }

	unless (defined $ip) { $ip = &get_ip( $host); }

	$html = "<HR>\n<B>$main::config{HTML}{TOOLS}</B>: \n";
	foreach $tool (@tools) {
		($fixed = $tool) =~ s# #&nbsp;#g;
		if ($fixed =~ /^([^:]+):(.*)$/) {
			$tool = $1;
			$fixed = $2;
		}

		unless (defined $main::config{TOOL}{$tool}) {
			warn "$host wants tool $tool, but it's not defined; skipped\n";
			next;
		}

		($thishtml) =  &do_subs(undef, undef, undef, $host, $ip, undef, 
			undef, $main::config{TOOL}{$tool});
		$html .= <<"EOD_TOOL";
$main::config{HTML}{TOOLPREFIX}<A CLASS="BUT" HREF="$thishtml">$fixed</A>$main::config{HTML}{TOOLSUFFIX}
EOD_TOOL
	}
	$html .= "\n";
$html;
}

#--------------------------------------------------------- html_footer ---
sub html_footer {
	my $html = "<HR>\n<B>Links:</B> ";

	if (defined $main::config{HOMEURL}) {
		$html .= <<"EOD_HOME";
$main::config{HTML}{LINKPREFIX}<A CLASS="BUT" HREF="$main::config{HOMEURL}">Home</A>$main::config{HTML}{LINKSUFFIX}
EOD_HOME
	}

	if (defined $main::config{TOPURL}) {
		$html .= <<"EOD_TOP";
$main::config{HTML}{LINKPREFIX}<A CLASS="BUT" HREF="$main::config{TOPURL}">Top</A>$main::config{HTML}{LINKSUFFIX}
EOD_TOP
	}

	if (defined $main::config{SRCURL}) {
		$html .= <<"EOD_SRC";
$main::config{HTML}{LINKPREFIX}<A CLASS="BUT" HREF="$main::config{SRCURL}index.html"><IMG SRC="$main::config{HTMLURL}/IMAGES/remstats.gif" BORDER="0" ALIGN="TOP" ALT="remstats"></A>$main::config{HTML}{LINKSUFFIX}
EOD_SRC
	}

	$html .= <<"EOD_RRDTOOL";
$main::config{HTML}{LINKPREFIX}<A CLASS="BUT" HREF="http://ee-staff.ethz.ch/~oetiker/webtools/rrdtool"><IMG SRC="$main::config{HTMLURL}/IMAGES/rrdtool.gif" BORDER="0" ALIGN="TOP" ALT="RRDtool"></A>$main::config{HTML}{LINKSUFFIX}
EOD_RRDTOOL

# Now the user-supplied links
	my ($name, $url);
	if (defined $main::config{LINKS}) {
		foreach my $link (@{$main::config{LINKS}}) {
			$name = $$link{NAME};
			$url = $$link{URL};

# It's not really a name, it's HTML
			if ($name =~ /^</) {
				$html .= <<"EOD_HTML";
<A HREF="$url">$name</A>
EOD_HTML
			}
			else {
				$html .= <<"EOD_TEXT";
$main::config{HTML}{LINKPREFIX}<A CLASS="BUT" HREF="$url">$name</A>$main::config{HTML}{LINKSUFFIX}
EOD_TEXT
			}
		}
	}

	my $now = time;
	my $updated = &timestamp($now);

	$html .= <<"EOD_LASTCHANGE";
<BR>\n<FONT SIZE="-1">This page last updated on $updated</FONT>.
</BODY>
</HTML>
EOD_LASTCHANGE

$html;
}

#-------------------------------------------------------- status_header ---
sub status_header {
	my ($host, $ip) = @_;
	my ($status, $stale, $file, $interfaces, @files, $interface, $html,
		$hostdesc, $name, $email, $show_interfaces);

	unless (defined $main::includer) { $main::includer = 'RRD::INCLUDE'; }

	$html = "<HR>\n<TABLE WIDTH=\"100%\">\n";

# What is this host anyway?
	$hostdesc = $main::config{HOST}{$host}{DESC} 
		if (defined $main::config{HOST}{$host}{DESC});
	if (defined $hostdesc) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{DESCRIPTION} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP>' . $hostdesc . '</TD></TR>' . "\n";
	}

# Who do we talk to
	if (defined $main::config{HOST}{$host}{CONTACTNAME}) {
		$name = $main::config{HOST}{$host}{CONTACTNAME};
		$email = $main::config{HOST}{$host}{CONTACTEMAIL};
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{CONTACT} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP>'. $name .
			' &lt;<A HREF="mailto:' . $email . '">' . $email .
			'</A>&gt;</TD></TR>' . "\n";
	}

# IP numbers are good to see
	unless (defined $ip) { $ip = &get_ip( $host); }
	if (defined $ip) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{IPNUMBER} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP>' . $ip . '</TD></TR>' . "\n";
	}

# Collect the software description (Operating System usually)
	$file = "$main::config{DATADIR}/$host/SOFTWARE";
	if (-f $file) {
		$html .= "\t". '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{OPERATINGSYSTEM} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
			'></TD></TR>' . "\n";
	}

# Collect the host hardware description
	$file = "$main::config{DATADIR}/$host/HARDWARE";
	if (-f $file) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{HARDWARE} .':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
			'></TD></TR>' ."\n";
	}

# Collect the interfaces
	$show_interfaces = (defined $main::config{HOST}{$host}{SHOWINTERFACES}) ?
		$main::config{HOST}{$host}{SHOWINTERFACES} :
		$main::config{HTML}{SHOWINTERFACES};
	if ($show_interfaces) {
		@files = &list_files("$main::config{DATADIR}/$host", 'HARDWARE-snmpif-*');
		push @files, &list_files("$main::config{DATADIR}/$host", 'HARDWARE-if-*');
		push @files, &list_files("$main::config{DATADIR}/$host", 'HARDWARE-ntnetworkinterface-*');
		undef $interfaces;
		foreach (@files) {
			open (INTERFACE, "<$_") or do {
				&error("can't open $_: $!");
				next;
			};
			($interface = $_) =~ s/.*-([^-]+)$/$1/;
			if (defined $interfaces) {
				$interfaces .= "<BR>\n". $interface .': '. 
					join('', <INTERFACE>);
			}
			else { $interfaces = $interface .': '. join('', <INTERFACE>); }
			close (INTERFACE);
		}
		if ($interfaces) {
			$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
				$main::config{HTML}{INTERFACES} . ':</B></TD>' .
				'<TD CLASS="VALUE" VALIGN=TOP>' . $interfaces . '</TD></TR>' . "\n";
		}
	}

# Make a pretty uptime display
	$file = "$main::config{DATADIR}/$host/UPTIME.html";
	if (-f $file) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{UPTIME} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
			'></TD></TR>' . "\n";
	}
	$file = "$main::config{DATADIR}/$host/STATUS.html";
	if (-f $file) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{STATUS} .':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file . '> at ';
		if ($main::includer eq 'RRD::INCLUDE') {
			$html .= '<RRD::TIME::NOW "%Y-%m-%d %H:%M:%S"></TD></TR>' . "\n";
		}
		else {
			$html .= '<DATAPAGE::VAR now></TD></TR>' . "\n";
		}
	}

	$html .= "</TABLE>\n";

$html;
}

#-------------------------------------------------------- rrd_status_header ---
sub rrd_status_header {
	my ($host, $realrrd, $wildrrd, $fixedrrd, $graph) = @_;
	my ($status, $stale, $printed);
	unless (defined $main::includer) { $main::includer = 'RRD::INCLUDE'; }

	my $html = "<!-- rrd-status -->\n";
	$html .= "<HR>\n<TABLE WIDTH=\"100%\">\n";

	if (defined $main::config{HOST}{$host}{RRDDESC}{$realrrd}) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{DESCRIPTION} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP>' . 
			$main::config{HOST}{$host}{RRDDESC}{$realrrd} .
			'</TD></TR>' . "\n";
	}

	if (defined $main::config{RRD}{$wildrrd}{GRAPHDESC}{$graph}) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{DESCRIPTION} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP>' . 
			$main::config{RRD}{$wildrrd}{GRAPHDESC}{$graph} . 
			'</TD></TR>' . "\n";
	}

	my $file = "$main::config{DATADIR}/$host/SOFTWARE-$fixedrrd";
	if (-f $file) {
		$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
			$main::config{HTML}{OPERATINGSYSTEM} . ':</B></TD>' .
			'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
			'></TD></TR>' . "\n";
	}

	$file = "$main::config{DATADIR}/HARDWARE-.$fixedrrd";
	if (-f $file) {
	$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' .
		$main::config{HTML}{HARDWARE} .':</B></TD>' .
		'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
		'></TD></TR>' . "\n";
	}

	$file = "$main::config{DATADIR}/$host/STATUS-$fixedrrd";
	if (-f $file) {
	$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' . 
		$main::config{HTML}{STATUS} . ':</B></TD>' .
		'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
		'></TD></TR>' . "\n";
	}

	$file = "$main::config{DATADIR}/$host/COMMENT-$fixedrrd";
	if (-f $file) {
	$html .= "\t" . '<TR><TD CLASS="LABEL" VALIGN=TOP><B>' . 
		$main::config{HTML}{COMMENT} .':</B></TD>' .
		'<TD CLASS="VALUE" VALIGN=TOP><' . $main::includer .' '. $file .
		'></TD></TR>' . "\n";
	}

	$html .= "</TABLE>\n";

$html;
}

#----------------------------------------------------- make_custom_graph ---
sub make_custom_graph {
	my ($dir, $prefix, $customgraph, $graphtime) = @_;
	my ($rrdgraph, $graphfile);

	$graphfile = $customgraph .'-'. $graphtime .'.'. $main::config{IMAGETYPE};
	if (defined $prefix) { $graphfile = $prefix .'-'. $graphfile; }
	if (defined $dir) { $graphfile = $dir .'/'. $graphfile; }

	$rrdgraph = '<RRD::GRAPH '. $graphfile .
		' --lazy'.
		' --start '. $main::config{TIME}{$graphtime}{START};
	unless ($main::config{TIME}{$graphtime}{FINISH} == 0) {
		$rrdgraph .= ' --end '. $main::config{TIME}{$graphtime}{FINISH};
	}
	$rrdgraph .= ' --imgformat '. $main::config{IMAGETYPE} .
		' --imginfo \'<IMG SRC="%s" WIDTH="%lu" HEIGHT="%lu" ALT="' .
		$customgraph .' '. $graphtime .'">\' ' .
		" '". join("' '", &do_subs(undef, undef, undef, undef, undef,
		$customgraph, $graphtime, 
		@{$main::config{CUSTOMGRAPH}{$customgraph}{GRAPH}})) ."'>";
	
$rrdgraph;
}

#------------------------------------------------------- make_rrdcgi_graph ---
sub make_rrdcgi_graph {
	my ($dir, $prefix, $host, $realrrd, $graph, $graphtime, $alttext) = @_;
	my ($realgraph, $rrdfile, $wildrrd, $wildpart, $fixedrrd, $fixedgraph);
	my ($rrdgraph, $rrddesc);

	($wildrrd, $wildpart, undef, $fixedrrd) = &get_rrd($realrrd);
	unless (defined $wildrrd) {
		&error("make_rrdcgi_graph: unknown rrd '$realrrd'; skipped graph '$graph'");
		return "[unknown rrd '$realrrd' for graph '$graph']";
	}
	unless (defined $main::config{RRD}{$wildrrd}{GRAPH}{$graph}) {
		&error("make_rrdcgi: unknown graph '$graph' in rrd '$realrrd'; skipped");
		return "[unknown graph '$graph' in rrd '$wildrrd' for '$realrrd']";
	}

	unless (defined $main::includer) { $main::includer = 'RRD::INCLUDE'; }
	$realgraph = $graph;
	if (defined $wildpart) { $realgraph =~ s/\*/$wildpart/; }
	$fixedgraph = &to_filename($realrrd .'-'. $graph .'-'. $graphtime .'.'.
		$main::config{IMAGETYPE});
	if (defined $prefix) { $fixedgraph = $prefix .'-'. $fixedgraph; }
	if (defined $dir) { $fixedgraph = $dir .'/'. $fixedgraph; }

	$rrdgraph = '<RRD::GRAPH '. $fixedgraph .' --lazy ';
	$rrdgraph .= '--start '.  $main::config{TIME}{$graphtime}{START};
	unless ($main::config{TIME}{$graphtime}{FINISH} == 0) {
		$rrdgraph .= ' --end '. $main::config{TIME}{$graphtime}{FINISH};
	}

# Now stick in the description
	if (defined $main::config{HOST}{$host}{RRDDESC}{$realrrd}) {
		$rrddesc = $main::config{HOST}{$host}{RRDDESC}{$realrrd} .' ';
	}
	else { $rrddesc = ''; }

# and here's the IMG tag
	if (defined $dir) { $dir .= '/'; }
	else { $dir=''; }
	$rrdgraph .= ' --imgformat '. $main::config{IMAGETYPE} .
		' --imginfo \'<IMG SRC="'. $dir. '%s" WIDTH="%lu" HEIGHT="%lu" ALT="';

# ... the alt text
	if (defined $alttext) {
		$alttext =~ s/"/\&quot;/g;
		$alttext =~ s/'/\&#39;/g;
		$rrdgraph .= $alttext . '">\' ';
	}
	else {
		$rrdgraph .= $rrddesc .'['. $host .' '. $realgraph .' '. $graphtime .']">\' ';
	}

# Hack to get the thumbnails to show up right
	if ($graphtime eq 'thumb') {
		$rrdgraph .= "<$main::includer ". $main::config{DATADIR} .'/'. $host 
			.'/STATUS-BACKGROUND.html>';
		$rrdgraph .= ' --width '. $main::config{THUMBWIDTH} .
			' --height '. $main::config{THUMBHEIGHT};
	}

	$rrdfile = $main::config{DATADIR} .'/'. $host .'/'. $fixedrrd .'.rrd';
	my @temp;
	if ($graphtime eq 'thumb') { @temp = @{$main::config{RRD}{$wildrrd}{GRAPH}{'thumb'}}; }
	else { @temp = @{$main::config{RRD}{$wildrrd}{GRAPH}{$graph}}; }
	$rrdgraph .= " '". join("' '", &do_subs($rrdfile, $realrrd, $wildpart, 
		$host, undef, $realgraph, $graphtime, @temp));
	$rrdgraph .= "'>";

$rrdgraph;
}

#--------------------------------------------------------------------------- header_bar ---
sub header_bar {
	my $text = join('', @_);
	$text = $main::config{HTML}{GROUPPREFIX} . $text .
		$main::config{HTML}{GROUPSUFFIX};
# returning $text
}

# say it's OK
1;
