# remstats.pl -- common routines for remstats programs
# $Id: remstats.pl.in,v 1.49 2001/08/28 15:22:24 remstats Exp $

# Copyright 1999, 2000, 2001 (c) Thomas Erskine <thomas.erskine@sourceworks.com>
# See the COPYRIGHT file with the distribution.

use strict;

# $Revision: 1.49 $

#-------------------------------------------------------------- subs ---
# &read_config_dir( $config_dir); # note: no return value
# @args = &do_subs($rrdfile, $realrrd, $wildpart, $hostname, $ip,
#	$graph, $graphtime, @args);
# ($wildrrd, $wildpart, $extra, $fixedrrd, $realrrd) = &get_rrd($rrdspec);
# $ip = &get_ip($hostname);
# &read_ip_cache(); # called by get_ip, if necessary
# &write_ip_cache(); # called at END to save any changes
# $ok = &make_a_dir ($dir);
# &put_status, ($host, $file, $status);
# ($status, $stale) = &get_status ( $host, $file);
# $filename = &to_filename($rrd_or_whatever);
# $string = &siunits($number);
# $string = &timestamp($secs);
# &testout($msg);
# @files = &list_files($dir [, $pattern]);

#-------------------------------------------------------------- config ---

# Here's roughly how %main::config gets constructed

# $config{DATADIR} = $value;
# $config{HTMLDIR} = $value;
# $config{HTMLURL} = $value;
# ($config{THUMBWIDTH}, $config{THUMBHEIGHT}) = split('x',$value,2);
# ($config{METADIR}, $config{METASUFFIX}) = split(' ',$value);
# $config{WEBMASTER} = $value;
# $config{BACKGROUND} = $value;
# $config{GROUPS} = [&make_array($value)];
# $config{STALETIME} = seconds;
# $config{MINUPTIME} = seconds;
# $config{KEEPALERTS} = seconds;
# $config{UPTIMEALERT} = seconds;
# $config{HTMLREFRESH} = seconds;
# $config{UPSTATUS} = $value;
# $config{UPUNSTABLESTATUS} = $value;
# $config{DOWNSTATUS} = $value;
# $config{DOWNUNSTABLESTATUS} = $value;
# $config{OKSTATUS} = $value;
# $config{WARNSTATUS} = $value;
# $config{ERRORSTATUS} = $value;
# $config{CRITICALSTATUS} = $value;
# $config{LOGOURL} = $value;
# $config{HOMEURL} = $value;
# $config{TOPURL} = $value;
# $config{SRCURL} = $value;
# @{$config{REMOTEPING}} = (remote-ping-servers);
# $config{DATAPAGEDIR} = $value;
# $config{RRDCGI} = $value;
# $config{LOGDIR} = $value;
# $config{TRAPIGNORE} = $value;
# $config{COMMUNITY} = $value;
# $config{WATCHDOGTIMER} = $value;
# $config{IMAGETYPE} = $value;
# $config{PINGER} = $value;
# $config{COLLECTORS} = [ @values ];
# $config{MONITORS} = [ @values ];
# $config{PAGEMAKERS} = [ @values ];
# $config{MAXPORTPATTERNS} = $value;
# $config{FORCECOLLECTION} = $value;
# $config{TEMPDIR} = $value;
# $config{KEEPLOGS} = $value;
#
# $config{HTML}{ALERTINDEX} = $value;
# $config{HTML}{ALERTREPORT} = $value;
# $config{HTML}{ALERTFLAGCRITICAL} = $html;
# $config{HTML}{ALERTFLAGERROR} = $html;
# $config{HTML}{ALERTFLAGWARN} = $html;
# $config{HTML}{CUSTOMINDEX} = $value;
# $config{HTML}{LOGREPORT} = $value;
# $config{HTML}{OVERALLINDEX} = $value;
# $config{HTML}{PINGINDEX} = $value;
# $config{HTML}{RRDINDEX} = $value;
# $config{HTML}{QUICKINDEX} = $value;
# $config{HTML}{INDICES} = $value;
# $config{HTML}{LINKS} = $value;
# $config{HTML}{TOOLS} = $value;
# push @{$config{HTML}{DEFAULTTOOLS}}, split(' ', $value);
# $config{HTML}{DESCRIPTION} = $value;
# $config{HTML}{IPNUMBER} = $value;
# $config{HTML}{INTERFACES} = $value;
# $config{HTML}{OPERATINGSYSTEM} = $value;
# $config{HTML}{HARDWARE} = $value;
# $config{HTML}{UPTIME} = $value;
# $config{HTML}{STATUS} = $value;
# $config{HTML}{LASTUPDATEON} = $value;
# $config{HTML}{COMMENT} = $value;
# $config{HTML}{CONTACT} = $value;
# $config{HTML}{HOSTINDEX} = $value;
# $config{HTML}{GROUPINDEX} = $value;
# $config{HTML}{VIEWINDEX} = $value;
# $config{HTML}{VIEWINDICES} = $value;
# $config{HTML}{SHOWINTERFACES} = $value;
# $config{HTML}{KEEPIMAGES} = $value;
# $config{HTML}{INDEXPREFIX} = $value;
# $config{HTML}{INDEXSUFFIX} = $value;
# $config{HTML}{GROUPPREFIX} = $value;
# $config{HTML}{GROUPSUFFIX} = $value;
# $config{HTML}{HOSTPREFIX} = $value;
# $config{HTML}{HOSTSUFFIX} = $value;
# $config{HTML}{TOOLPREFIX} = $value;
# $config{HTML}{TOOLSUFFIX} = $value;
# $config{HTML}{LINKPREFIX} = $value;
# $config{HTML}{LINKSUFFIX} = $value;
# $config{HTML}{OUTOFRANGEPREFIX} = $value;
# $config{HTML}{OUTOFRANGESUFFIX} = $value;
#
# $config{OID}{$name} = $value;
#
# $config{TIME}{$name}{START} = eval $start;
# $config{TIME}{$name}{FINISH} = eval $finish;
# 
# $config{COLOR}{$name} = $value;
# 
# $config{ARCHIVE}{$name} = $value;
#
# push @{$config{LINKS}}, {
# 	NAME => $name,
# 	URL => $value
# };
# 
# $config{TOOL}{$name} = $value;
# 
# $config{SCRIPT}{$script}{SEND} = script-string
# $config{SCRIPT}{$script}{TIMEOUT} = seconds
# $config{SCRIPT}{$script}{PORT} = portnum
# $config{SCRIPT}{$script}{INFOPATTERN} = regex
# $config{SCRIPT}{$script}{VALUEPATTERN} = regex
# push @{$config{SCRIPT}{$script}{TESTS}}, uc $name;
# $config{SCRIPT}{$script}{uc $name} = $value;
#
# push @{$config{ALERT}} , {
# 	LEVEL => $level,
# 	HOST => $host,
# 	RRD => $realrrd,
# 	VAR => $var,
# 	MINTIME => $mintime,
# 	INTERVAL => $interval,
# 	PROG => $prog,
#  	ADDRESSES => [ @addresses ],
# };
# 
# $config{RRD}{$wildrrd}{STEP} = $1;
# $config{RRD}{$wildrrd}{SOURCE} = $1;
# $config{COLLECTOR}{$collector}{$wildrrd} = 1;
# $config{HOSTCOLLECTEDBY}{$collector}{$host} = 1;
# $config{RRD}{$wildrrd}{$name}{ALIAS} = lc $alias;
# $config{RRD}{$wildrrd}{$name}{DS} = lc $ds;
# $config{RRD}{$wildrrd}{$name}{EXTRA} = $extra;
# push @{$config{RRD}{$wildrrd}{DATANAMES}}, $name;
# $config{RRD}{$wildrrd}{ARCHIVES} = [split(' ',$1)];
# $config{RRD}{$wildrrd}{TIMES} = [split(' ',$1)];
# $config{RRD}{$wildrrd}{ALERT}{$var}{RELATION} = $relation;
# $comfig{RRD}{$wildrrd}{ALERT}{$var}{NODATA} = $status;
# $config{RRD}{$wildrrd}{PORT} = $port;
# @{$config{RRD}{$wildrrd}{ALERT}{$var}{VALUES}} = split(' ',$values);
# $config{RRD}{$wildrrd}{GRAPHDESC}{$graph} = $desc;
# push @{$config{RRD}{$wildrrd}{GRAPHS}}, $graph;
# push @{$config{RRD}{$wildrrd}{GRAPH}{$graph}}, &make_array($1);
# push @{$config{RRD}{$wildrrd}{OIDS}}, $config{OID}{$oidname};
# $config{RRD}{$wildrrd}{STATUSFILE}{$statusfile} = $variables
# 
# $config{HOST}{$host}{IP} = ip;
# $config{HOST}{$host}{VIA} = iplist;
# push @{$config{HOST}{$host}{ALIAS}}, @aliases
# $config{HOST}{$host}{GROUP} = group;
# $config{HOST}{$host}{COMMUNITY} = snmp-community
# $config{HOST}{$host}{LOCATION} = lat long text-comment
# $config{HOST}{$host}{CONTACTNAME} = Name Here
# $config{HOST}{$host}{CONTACTEMAIL} = email@address
# $config{HOST}{$host}{DESC} = description here;
# push @{$config{HOST}{$host}{RRDS}}, $realrrd;
# $config{HOST}{$host}{NOGRAPH}{$realrrd}{$graph} = 1;
# $config{HOST}{$host}{EXTRA}{$realrrd} = $extra;
# $config{HOST}{$host}{RRDDESC}{$realrrd} = $rrddesc;
# @{$config{HOST}{$host}{TOOLS}} = split(' ',$1);
# $config{HOST}{$host}{ALERT}{$realrrd}{$var}{RELATION} = $relation;
# $config{HOST}{$host}{ALERT}{$realrrd}{$var}{NODATA} = $status;
# @{$config{HOST}{$host}{ALERT}{$realrrd}{$var}{VALUES}} = split(' ',$values);
# $config{HOST}{$host}{ALERT}{$realrrd}{$var}{NOALERT} = 1;
# push @{$config{GROUP}{$group}}, $host;
# $config{HOST}{$host}{SNMPPORT} = $port;
# $config{HOST}{$host}{TAG}{$tag} = 1;
# push @{$main::config{HOST}{$host}{CUSTOMGRAPHS}}, $value;
# $config{HOST}{$host}{STATUSFILE} = $value;
# $config{HOST}{$host}{NTSTATUSSERVER} = $value;
# push @{$main::config{HOST}{$host}{NTINDIRECTHOSTS}, $ntserver;
# $config{HOST}{$host}{NTNAME} = $value;
# $config{HOST}{$host}{NOAVAILABILITY}{$realrrd}{$var} = 1;
# $config{HOST}{$host}{SHOWINTERFACES} = 1;

# push @{$config{CUSTOMGRAPHS}}, $graphname;
# push @{$config{CUSTOMGRAPH}{$graphname}{GRAPH}}, &make_array(graphspec);
# @{$config{CUSTOMGRAPH}{$graphname}{TIMES}} = split(' ',$_);
# $config{CUSTOMGRAPH}{$graphname}{DESC} = $graphname;

# $config{VIEW}{$view}{DESC} = $value;
# $config{VIEW}{$view}{TEMPLATE} = $value;
# $config{VIEW}{$view}{DATAPAGE} = $value;
# push @{$config{VIEW}{$view}{GRAPHS}}, "graph $1 $2 $3" or "customgraph $1"

# $config{ALERTTEMPLATE}{RRD}{$real_or_wild_rrd}
# $config{ALERTTEMPLATE}{ADDRESS}{$address_pattern}

# $config{RRDAVAIL}{$real_or_wild_rrd}{$varname}{CF} = $cf
# $config{RRDAVAIL}{$real_or_wild_rrd}{$varname}{RELATION} = $relation
# $config{RRDAVAIL}{$real_or_wild_rrd}{$varname}{THRESHOLD} = $threshold
# $config{HOSTAVAIL}{$host}{$real_or_wild_rrd}{$varname}{CF} = $cf
# $config{HOSTAVAIL}{$host}{$real_or_wild_rrd}{$varname}{RELATION} = $relation
# $config{HOSTAVAIL}{$host}{$real_or_wild_rrd}{$varname}{THRESHOLD} = $threshold
# $config{AVAILCOLORS} = [ @colors ]
# $config{AVAILTHRESHOLDS} = [ @thresholds ]

# push @{$config{ALERTDEST}{DEST}} = [ $dest, $time, $dow, $dom, $mon, $alias ];
# $config{ALERTDEST}{ALIAS}{$alias} = @method_addrs;
# $config{ALERTDEST}{METHOD}{$method} = $command_line;

# $config{DISCOVERY}{NTSTATUSSERVER} = $value;
# $config{DISCOVERY}{NTDOMAIN} = $value;
# $config{DISCOVERY}{DNSDOMAIN} = $value;
# $config{DISCOVERY}{SUBNETS} = $value;

use Socket;
use Fcntl ':flock'; # import LOCK_* constants

%main::statuses = (
	'NODATA'	=> 0, 0 => 'NODATA',
	'OK'		=> 1, 1 => 'OK',
	'WARN'		=> 2, 2 => 'WARN',
	'ERROR'		=> 3, 3 => 'ERROR',
	'CRITICAL'	=> 4, 4 => 'CRITICAL',
);

#----------------------------------------------------- read_config_dir ---
# Remember to update check-config whenever you add a new section here.
sub read_config_dir {
	my ($configdir, @elements) = @_;
	my $errors = 0;

	unless (-d $configdir) {
		&abort("missing config-dir ($configdir)");
	}
	&debug("reading configuration") if ($main::config_debug);

# Untaint the configdir, so perl stops whinging
	if ($configdir =~ /^(.*)$/) {
		$configdir = $1;
	}

	foreach my $element (@elements) {
		if ($element eq 'general') {
			$errors += &read_config_general($configdir);
		}
		elsif ($element eq 'html') {
			$errors += &read_config_html($configdir);
		}
		elsif ($element eq 'times') {
			$errors += &read_config_times($configdir);
		}
		elsif ($element eq 'colors') {
			$errors += &read_config_colors($configdir);
		}
		elsif ($element eq 'archives') {
			$errors += &read_config_archives($configdir);
		}
		elsif ($element eq 'links') {
			$errors += &read_config_links($configdir);
		}
		elsif ($element eq 'tools') {
			$errors += &read_config_tools($configdir);
		}
		elsif ($element eq 'remotepings') {
			$errors += &read_config_remotepings($configdir);
		}
		elsif ($element eq 'scripts') {
			$errors += &read_config_scripts($configdir);
		}
		elsif ($element eq 'alerts') {
			$errors += &read_config_alerts($configdir);
		}
		elsif ($element eq 'oids') {
			$errors += &read_config_oids($configdir);
		}
		elsif ($element eq 'rrds') {
			$errors += &read_config_rrds($configdir);
		}
		elsif ($element eq 'customgraphs') {
			$errors += &read_config_customgraphs($configdir);
		}
		elsif ($element eq 'groups') {
			$errors += &read_config_groups($configdir);
		}
		elsif ($element eq 'view-templates') {
			$errors += &read_config_view_templates($configdir);
		}
		elsif ($element eq 'views') {
			$errors += &read_config_views($configdir);
		}
		elsif ($element eq 'hosts') {
			$errors += &read_config_hosts($configdir, 'hosts', 'HOST');
		}
		elsif ($element eq 'host-templates') {
			$errors += &read_config_hosts($configdir, 'host-templates', 'HOSTTEMPLATE');
		}
		elsif ($element eq 'alert-template-map') {
			$errors += &read_config_alert_template_map($configdir);
		}
		elsif ($element eq 'availability') {
			$errors += &read_config_availability($configdir);
		}
		elsif ($element eq 'alert-destination-map') {
			$errors += &read_config_alert_destination_map($configdir);
		}
		elsif ($element eq 'discovery') {
			$errors += &read_config_discovery($configdir);
		}
		else {
			&error("read_config_dir: unknown config section ($element); skipped");
			++$errors;
		}
		&abort("$errors errors found") if ($errors > 0);
	}
}

#------------------------------------------------- read_config_general ---
sub read_config_general {
	my ($configdir) = @_;
	my $configfile = $configdir .'/general';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_general: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading general configuration") if ($main::config_debug);
	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		if ($name eq 'datadir') {
			$main::config{DATADIR} = $value;
			&debug("  datadir $main::config{DATADIR}") if ($main::config_debug);
		}
		elsif ($name eq 'staletime') {
			$main::config{STALETIME} = $value;
			&debug("  staletime = $main::config{STALETIME}") if ($main::config_debug);
		}
		elsif ($name eq 'minuptime') {
			$main::config{MINUPTIME} = $value;
			&debug("  minuptime = $main::config{MINUPTIME}") if ($main::config_debug);
		}
		elsif ($name eq 'keepalerts') {
			$main::config{KEEPALERTS} = $value;
			&debug("  keepalerts = $main::config{KEEPALERTS}") if ($main::config_debug);
		}
		elsif ($name eq 'uptimealert') {
			$main::config{UPTIMEALERT} = $value;
			&debug("  uptimealert = $main::config{UPTIMEALERT}") if ($main::config_debug);
		}
		elsif ($name eq 'datapagedir') {
			$main::config{DATAPAGEDIR} = $value;
			&debug("  datapagedir $value") if ($main::config_debug);
		}
		elsif ($name eq 'logdir') {
			$main::config{LOGDIR} = $value;
			&debug("  logdir $value") if ($main::config_debug);
		}
		elsif ($name eq 'trapignore') {
			$main::config{TRAPIGNORE} = $value;
			&debug("  trapignore $value") if ($main::config_debug);
		}
		elsif ($name eq 'community') {
			$main::config{COMMUNITY} = $value;
			&debug("  community $value") if ($main::config_debug);
		}
		elsif ( $name eq 'watchdogtimer') {
			$main::config{WATCHDOGTIMER} = $value;
			&debug("  watchdogtimer $value") if ($main::config_debug);
		}
		elsif ( $name eq 'tempdir') {
			$main::config{TEMPDIR} = $value;
			&debug("  tempdir $value") if ($main::config_debug);
		}
		elsif ( $name eq 'pinger') {
			$main::config{PINGER} = $value;
			&debug("  pinger $value") if ($main::config_debug);
		}
		elsif ( $name eq 'collectors') {
			$main::config{COLLECTORS} = [ split(' ',$value) ];
			&debug("  collectors $value") if ($main::config_debug);
		}
		elsif ( $name eq 'monitors') {
			$main::config{MONITORS} = [ split(' ',$value) ];
			&debug("  monitors $value") if ($main::config_debug);
		}
		elsif ( $name eq 'pagemakers') {
			$main::config{PAGEMAKERS} = [ split(' ', $value) ] ;
			&debug("  pagemaker $value") if ($main::config_debug);
		}
		elsif ( $name eq 'max-port-patterns') {
			$main::config{MAXPORTPATTERNS} = $value;
			&debug("  max-port-patterns $value") if ($main::config_debug);
		}
		elsif ( $name eq 'keeplogs') {
			$value = $1;
			$main::config{KEEPLOGS} = $value;
			&debug("  keeplogs $value") if ($main::config_debug);
		}
		elsif ( $name eq 'force-collection') {
			if ($value =~ /^(yes|y|t|true|on)$/i) { $value = 1; }
			elsif ($value =~ /^(no|n|f|false|off)$/i) { $value = 0; }
			else {
				++$errors;
				&error("read_config_general: unknown value for force-collection ($value)");
				next;
			}
			$main::config{'FORCECOLLECTION'} = $value;
			&debug("  force-collection $value") if ($main::config_debug);
		}
		else {
			++$errors;
			&error("read_config_general: unknown line: $_");
			next;
		}
	}
	close (CONFIG);

# Now some checks to make sure we have required stuff
	unless (defined $main::config{DATADIR}) {
		&error("read_config_general: datadir not defined");
		++$errors;
	}

# Some required stuff can be safetly defaulted
	unless (defined $main::config{DATAPAGEDIR}) { $main::config{DATAPAGEDIR} = '/etc/remstats/config/datapages'; }
	unless (defined $main::config{STALETIME}) { $main::config{STALETIME} = 30*60; }
	unless (defined $main::config{MINUPTIME}) { $main::config{MINUPTIME} = 24*60*60; }
	unless (defined $main::config{KEEPALERTS}) { $main::config{KEEPALERTS} = 24*60*60; }
	unless (defined $main::config{LOGDIR}) { $main::config{LOGDIR} = $main::config{DATADIR}.'/LOGS'; }
	unless (defined $main::config{WATCHDOGTIMER}) { $main::config{WATCHDOGTIMER} = 300; }
	unless (defined $main::config{TEMPDIR}) { $main::config{TEMPDIR} = '/var/lib/remstats/tmp'; }
	unless (defined $main::config{MAXPORTPATTERNS}) { $main::config{MAXPORTPATTERNS} = 15; }
	unless (defined $main::config{FORCECOLLECTION}) { $main::config{FORCECOLLECTION} = 1; }
	unless (defined $main::config{KEEPLOGS}) { $main::config{KEEPLOGS} = 365*24*60*60; } # one year

	unless (defined $main::config{COLLECTORS}) {
		$main::config{COLLECTORS} = [ 'ping', 'port', 'snmp-route', 'log', 
			'unix-status', 'snmp', 'nt-status' ];
	}
	unless (defined $main::config{MONITORS}) {
		$main::config{MONITORS} = [ 'ping', 'alert' ] ;
	}
	unless (defined $main::config{PAGEMAKERS}) {
		$main::config{PAGEMAKERS} = [ 'graph-writer', 'snmpif-setspeed', 
			'datapage-interfaces', 'datapage-inventory', 
			'datapage-status', 'view-writer' ];
	}

$errors;
}

#------------------------------------------------- read_config_html ---
sub read_config_html {
	my ($configdir) = @_;
	my $configfile = $configdir .'/html';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_html: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading html configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		if( $name eq 'alertindex') {
			$main::config{HTML}{ALERTINDEX} = $value;
			&debug("  alertindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'alertreport') {
			$main::config{HTML}{ALERTREPORT} = $value;
			&debug("  alertreport $value") if ($main::config_debug);
		}
		elsif ($name eq 'customindex') {
			$main::config{HTML}{CUSTOMINDEX} = $value;
			&debug("  customindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'logreport') {
			$main::config{HTML}{LOGREPORT} = $value;
			&debug("  logreport $value") if ($main::config_debug);
		}
		elsif ($name eq 'overallindex') {
			$main::config{HTML}{OVERALLINDEX} = $value;
			&debug("  overallindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'pingindex') {
			$main::config{HTML}{PINGINDEX} = $value;
			&debug("  pingindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'rrdindex') {
			$main::config{HTML}{RRDINDEX} = $value;
			&debug("  rrdindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'quickindex') {
			$main::config{HTML}{QUICKINDEX} = $value;
			&debug("  quickindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'indices') {
			$main::config{HTML}{INDICES} = $value;
			&debug("  indices $value") if ($main::config_debug);
		}
		elsif ($name eq 'links') {
			$main::config{HTML}{LINKS} = $value;
			&debug("  links $value") if ($main::config_debug);
		}
		elsif ($name eq 'tools') {
			$main::config{HTML}{TOOLS} = $value;
			&debug("  tools $value") if ($main::config_debug);
		}
		elsif ($name eq 'default-tools') {
			push @{$main::config{HTML}{DEFAULTTOOLS}}, split(' ', $value);
			&debug("  default-tools $value") if ($main::config_debug);
		}
		elsif ($name eq 'description') {
			$main::config{HTML}{DESCRIPTION} = $value;
			&debug("  description $value") if ($main::config_debug);
		}
		elsif ($name eq 'ipnumber') {
			$main::config{HTML}{IPNUMBER} = $value;
			&debug("  ipnumber $value") if ($main::config_debug);
		}
		elsif ($name eq 'interfaces') {
			$main::config{HTML}{INTERFACES} = $value;
			&debug("  interfaces $value") if ($main::config_debug);
		}
		elsif ($name eq 'operatingsystem') {
			$main::config{HTML}{OPERATINGSYSTEM} = $value;
			&debug("  operatingsystem $value") if ($main::config_debug);
		}
		elsif ($name eq 'hardware') {
			$main::config{HTML}{HARDWARE} = $value;
			&debug("  hardware $value") if ($main::config_debug);
		}
		elsif ($name eq 'uptime') {
			$main::config{HTML}{UPTIME} = $value;
			&debug("  uptime $value") if ($main::config_debug);
		}
		elsif ($name eq 'status') {
			$main::config{HTML}{STATUS} = $value;
			&debug("  status $value") if ($main::config_debug);
		}
		elsif ($name eq 'lastupdateon') {
			$main::config{HTML}{LASTUPDATEON} = $value;
			&debug("  lastupdateon $value") if ($main::config_debug);
		}
		elsif ($name eq 'comment') {
			$main::config{HTML}{COMMENT} = $value;
			&debug("  comment $value") if ($main::config_debug);
		}
		elsif ($name eq 'contact') {
			$main::config{HTML}{CONTACT} = $value;
			&debug("  contact $value") if ($main::config_debug);
		}
		elsif ($name eq 'hostindex') {
			$main::config{HTML}{HOSTINDEX} = $value;
			&debug("  hostindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'groupindex') {
			$main::config{HTML}{GROUPINDEX} = $value;
			&debug("  groupindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'viewindex') {
			$main::config{HTML}{VIEWINDEX} = $value;
			&debug("  viewindex $value") if ($main::config_debug);
		}
		elsif ($name eq 'viewindices') {
			if ($value =~ /^(yes|on|true|1)|(no|off|false|0)$/) {
				$value = (defined $1) ? 1 : 0 ;
			}
			else {
				&error("read_config_html: viewindices must be yes or no, not '$value'");
				++$errors;
				next;
			}
			$main::config{HTML}{VIEWINDICES} = $value;
			&debug("  viewindices $value") if ($main::config_debug);
		}
		elsif ($name eq 'showinterfaces') {
			if ($value =~ /^(yes|on|true|1)|(no|off|false|0)$/) {
				$value = (defined $1) ? 1 : 0 ;
			}
			else {
				&error("read_config_html: showinterfaces must be yes of no, not '$value'");
				++$errors;
				next;
			}
			$main::config{HTML}{SHOWINTERFACES} = $value;
			&debug("  showinterfaces $value") if ($main::config_debug);
		}
		elsif( $name eq 'indexprefix') {
			$main::config{HTML}{INDEXPREFIX} = &do_escapes($value);
			&debug("  indexprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'indexsuffix') {
			$main::config{HTML}{INDEXSUFFIX} = &do_escapes($value);
			&debug("  indexsuffix $value") if ($main::config_debug);
		}
		elsif( $name eq 'groupprefix') {
			$main::config{HTML}{GROUPPREFIX} = &do_escapes($value);
			&debug("  groupprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'groupsuffix') {
			$main::config{HTML}{GROUPSUFFIX} = &do_escapes($value);
			&debug("  groupsuffix $value") if ($main::config_debug);
		}
		elsif( $name eq 'toolprefix') {
			$main::config{HTML}{TOOLPREFIX} = &do_escapes($value);
			&debug("  toolprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'toolsuffix') {
			$main::config{HTML}{TOOLSUFFIX} = &do_escapes($value);
			&debug("  toolsuffix $value") if ($main::config_debug);
		}
		elsif( $name eq 'hostprefix') {
			$main::config{HTML}{HOSTPREFIX} = &do_escapes($value);
			&debug("  hostprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'hostsuffix') {
			$main::config{HTML}{HOSTSUFFIX} = &do_escapes($value);
			&debug("  hostsuffix $value") if ($main::config_debug);
		}
		elsif( $name eq 'linkprefix') {
			$main::config{HTML}{LINKPREFIX} = &do_escapes($value);
			&debug("  linkprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'linksuffix') {
			$main::config{HTML}{LINKSUFFIX} = &do_escapes($value);
			&debug("  linksuffix $value") if ($main::config_debug);
		}
		elsif( $name eq 'outofrangeprefix') {
			$main::config{HTML}{OUTOFRANGEPREFIX} = &do_escapes($value);
			&debug("  outofrangeprefix $value") if ($main::config_debug);
		}
		elsif( $name eq 'outofrangesuffix') {
			$main::config{HTML}{OUTOFRANGESUFFIX} = &do_escapes($value);
			&debug("  outofrangesuffix $value") if ($main::config_debug);
		}
		elsif ($name eq 'alertflagwarn') {
			$main::config{HTML}{ALERTFLAGWARN} = $value;
			&debug("  alertflagwarn $value") if ($main::config_debug);
		}
		elsif ($name eq 'alertflagerror') {
			$main::config{HTML}{ALERTFLAGERROR} = $value;
			&debug("  alertflagerror $value") if ($main::config_debug);
		}
		elsif ($name eq 'alertflagcritical') {
			$main::config{HTML}{ALERTFLAGCRITICAL} = $value;
			&debug("  alertflagcritical $value") if ($main::config_debug);
		}

# From [general] and not properly integrated
		elsif ($name eq 'htmldir') {
			$main::config{HTMLDIR} = $value;
			&debug("  htmldir $main::config{HTMLDIR}") if ($main::config_debug);
		}
		elsif ($name eq 'htmlurl') {
			$main::config{HTMLURL} = $value;
			&debug("  htmlurl $main::config{HTMLURL}") if ($main::config_debug);
		}
		elsif ($name eq 'viewdir') {
			$main::config{HTML}{VIEWDIR} = $value;
			&debug("  viewdir $main::config{HTML}{VIEWDIR}") if ($main::config_debug);
		}
		elsif ($name eq 'viewurl') {
			$main::config{HTML}{VIEWURL} = $value;
			&debug("  viewurl $main::config{HTML}{VIEWURL}") if ($main::config_debug);
		}
		elsif ($name eq 'motdfile') {
			$main::config{HTML}{MOTDFILE} = $value;
			&debug("  motdfile $main::config{HTML}{MOTDFILE}") if ($main::config_debug);
		}
		elsif ($name eq 'thumbnail') {
			($main::config{THUMBWIDTH}, $main::config{THUMBHEIGHT}) =
				split('\s?x\s?',$value,2);
			unless (defined $main::config{THUMBHEIGHT}) {
				++$errors;
				&error("read_config_html: invalid thumbnail value '$value'");
				next;
			}
			&debug("  thumbnail $main::config{THUMBWIDTH}x$main::config{THUMBHEIGHT}") if ($main::config_debug);
		}
		elsif ($name eq 'metadata') {
			($main::config{METADIR}, $main::config{METASUFFIX}) =
				split(' ',$value);
			unless (defined $main::config{METASUFFIX}) {
				++$errors;
				&error("read_config_html: invalid metadata value '$value'");
				next;
			}
			&debug("  metadata $main::config{METADIR} $main::config{METASUFFIX}") if ($main::config_debug);
		}
		elsif ($name eq 'webmaster') {
			$main::config{WEBMASTER} = $value;
			&debug("  webmaster $main::config{WEBMASTER}") if ($main::config_debug);
		}
		elsif ($name eq 'background') {
			$main::config{BACKGROUND} = $value;
			&debug("  background $main::config{BACKGROUND}") if ($main::config_debug);
		}
		elsif ($name eq 'htmlrefresh') {
			$main::config{HTMLREFRESH} = $value;
			&debug("  htmlrefresh = $main::config{HTMLREFRESH}") if ($main::config_debug);
		}
		elsif ($name eq 'upstatus') {
			$main::config{UPSTATUS} = $value;
			&debug("  upstatus = $main::config{UPSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'upunstablestatus') {
			$main::config{UPUNSTABLESTATUS} = $value;
			&debug("  upunstablestatus = $main::config{UPUNSTABLESTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'downstatus') {
			$main::config{DOWNSTATUS} = $value;
			&debug("  downstatus = $main::config{DOWNSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'downunstablestatus') {
			$main::config{DOWNUNSTABLESTATUS} = $value;
			&debug("  downunstablestatus = $main::config{DOWNUNSTABLESTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'okstatus') {
			$main::config{OKSTATUS} = $value;
			&debug("  okstatus = $main::config{OKSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'warnstatus') {
			$main::config{WARNSTATUS} = $value;
			&debug("  warnstatus = $main::config{WARNSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'errorstatus') {
			$main::config{ERRORSTATUS} = $value;
			&debug("  errorstatus = $main::config{ERRORSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'criticalstatus') {
			$main::config{CRITICALSTATUS} = $value;
			&debug("  criticalstatus = $main::config{CRITICALSTATUS}") if ($main::config_debug);
		}
		elsif ($name eq 'logourl') {
			$main::config{LOGOURL} = $value;
			&debug("  logourl $main::config{LOGOURL}") if ($main::config_debug);
		}
		elsif ($name eq 'homeurl') {
			$main::config{HOMEURL} = $value;
			&debug("  homeurl $main::config{HOMEURL}") if ($main::config_debug);
		}
		elsif ($name eq 'topurl') {
			$main::config{TOPURL} = $value;
			&debug("  topurl $main::config{TOPURL}") if ($main::config_debug);
		}
		elsif ($name eq 'srcurl') {
			$main::config{SRCURL} = $value;
			&debug("  srcurl $main::config{SRCURL}") if ($main::config_debug);
		}
		elsif ($name eq 'rrdcgi') {
			$main::config{RRDCGI} = $value;
			&debug("  rrdcgi $value") if ($main::config_debug);
		}
		elsif ( $name eq 'imagetype') {
			if ($value =~ /^(gif|png)$/i) {
				$main::config{IMAGETYPE} = uc $1;
			}
			else {
				++$errors;
				&error("read_config_html: unknown imagetype ($value)");
				next;
			}
			&debug("  imagetype $1") if ($main::config_debug);
		}
		elsif ( $name eq 'uptimeflag') {
			$main::config{UPTIMEFLAG} = $value;
			&debug("  uptimeflag $value") if ($main::config_debug);
		}
		elsif ( $name eq 'keepimages') {
			$main::config{HTML}{KEEPIMAGES} = $value;
			&debug("  keepimages $value") if ($main::config_debug);
		}
		else {
			++$errors;
			&error("read_config_html: unknown line: $_");
			next;
		}
	}
	close (CONFIG);

# Some defaults
	unless (defined $main::config{HTML}{ALERTINDEX}) { $main::config{HTML}{ALERTINDEX} = 'Alert Index'; }
	unless (defined $main::config{HTML}{ALERTREPORT}) { $main::config{HTML}{ALERTREPORT} = 'Alert Report'; }
	unless (defined $main::config{HTML}{CUSTOMINDEX}) { $main::config{HTML}{CUSTOMINDEX} = 'Custom Index'; }
	unless (defined $main::config{HTML}{LOGREPORT}) { $main::config{HTML}{LOGREPORT} = 'Log Report'; }
	unless (defined $main::config{HTML}{OVERALLINDEX}) { $main::config{HTML}{OVERALLINDEX} = 'Overall Index'; }
	unless (defined $main::config{HTML}{PINGINDEX}) { $main::config{HTML}{PINGINDEX} = 'Ping Index'; }
	unless (defined $main::config{HTML}{RRDINDEX}) { $main::config{HTML}{RRDINDEX} = 'RRD Index'; }
	unless (defined $main::config{HTML}{QUICKINDEX}) { $main::config{HTML}{QUICKINDEX} = 'Quick Index'; }
	unless (defined $main::config{HTML}{INDICES}) { $main::config{HTML}{INDICES} = 'Indices'; }
	unless (defined $main::config{HTML}{LINKS}) { $main::config{HTML}{LINKS} = 'Links'; }
	unless (defined $main::config{HTML}{TOOLS}) { $main::config{HTML}{TOOLS} = 'Tools'; }
	unless (defined $main::config{HTML}{DESCRIPTION}) { $main::config{HTML}{DESCRIPTION} = 'Description'; }
	unless (defined $main::config{HTML}{IPNUMBER}) { $main::config{HTML}{IPNUMBER} = 'IP #'; }
	unless (defined $main::config{HTML}{INTERFACES}) { $main::config{HTML}{INTERFACES} = 'Interfaces'; }
	unless (defined $main::config{HTML}{OPERATINGSYSTEM}) {
		$main::config{HTML}{OPERATINGSYSTEM} = 'Operating System';
	}
	unless (defined $main::config{HTML}{HARDWARE}) { $main::config{HTML}{HARDWARE} = 'Hardware'; }
	unless (defined $main::config{HTML}{UPTIME}) { $main::config{HTML}{UPTIME} = 'Uptime'; }
	unless (defined $main::config{HTML}{STATUS}) { $main::config{HTML}{STATUS} = 'Status'; }
	unless (defined $main::config{HTML}{LASTUPDATEON}) {
		$main::config{HTML}{LASTUPDATEON} = 'This page last updated on';
	}
	unless (defined $main::config{HTML}{COMMENT}) { $main::config{HTML}{COMMENT} = 'Comment'; }
	unless (defined $main::config{HTML}{CONTACT}) { $main::config{HTML}{CONTACT} = 'Contact'; }
	unless (defined $main::config{HTML}{HOSTINDEX}) { $main::config{HTML}{HOSTINDEX} = 'Host Index'; }
	unless (defined $main::config{HTML}{GROUPINDEX}) { $main::config{HTML}{GROUPINDEX} = 'Group Index'; }
	unless (defined $main::config{HTML}{VIEWINDEX}) { $main::config{HTML}{VIEWINDEX} = 'View Index'; }
	unless (defined $main::config{HTML}{VIEWINDICES}) { $main::config{HTML}{VIEWINDICES} = 1; }
	unless (defined $main::config{HTML}{SHOWINTERFACES}) { $main::config{HTML}{SHOWINTERFACES} = 1; }
	unless (defined $main::config{HTML}{VIEWDIR}) {
		$main::config{HTML}{VIEWDIR} = $main::config{HTMLDIR} .'/VIEWS';
	}
	unless (defined $main::config{HTML}{VIEWURL}) {
		$main::config{HTML}{VIEWURL} = $main::config{HTMLURL} .'/VIEWS';
	}
	unless (defined $main::config{HTML}{MOTDFILE}) {
		$main::config{HTML}{MOTDFILE} = $main::config{HTMLDIR} .'/MOTD.html';
	}
	unless (defined $main::config{HTML}{KEEPIMAGES}) {
		$main::config{HTML}{KEEPIMAGES} = 24*60*60;
	}
	unless (defined $main::config{HTML}{DEFAULTTOOLS}) {
		$main::config{HTML}{DEFAULTTOOLS} = [ 'ping', 'traceroute', 'availability', 'status' ];
	}

# Now some checks to make sure we have required stuff
	unless (defined $main::config{HTMLDIR}) {
		&error("read_config_html: htmldir not defined");
		++$errors;
	}
	unless (defined $main::config{HTMLURL}) {
		&error("read_config_html: htmlurl not defined");
		++$errors;
	}
	unless (defined $main::config{WEBMASTER}) {
		&error("read_config_html: webmaster not defined");
		++$errors;
	}

# Some required stuff can be safetly defaulted
	unless (defined $main::config{THUMBWIDTH}) { $main::config{THUMBWIDTH} = 30; }
	unless (defined $main::config{THUMBHEIGHT}) { $main::config{THUMBHEIGHT} = 30; }
	unless (defined $main::config{METADIR}) { $main::config{METADIR} = '.web'; }
	unless (defined $main::config{METASUFFIX}) { $main::config{METASUFFIX} = '.meta'; }
	unless (defined $main::config{BACKGROUND}) { $main::config{BACKGROUND} = 'bgcolor="white"'; }
	unless (defined $main::config{UPSTATUS}) { $main::config{UPSTATUS} = 'UP'; }
	unless (defined $main::config{UPUNSTABLESTATUS}) { $main::config{UPUNSTABLESTATUS} = 'UPUNSTABLE'; }
	unless (defined $main::config{DOWNSTATUS}) { $main::config{DOWNSTATUS} = 'DOWN'; }
	unless (defined $main::config{DOWNUNSTABLESTATUS}) { $main::config{DOWNUNSTABLESTATUS} = 'DOWNUNSTABLE'; }
	unless (defined $main::config{LOGOURL}) { $main::config{LOGOURL} = 'LOGO'; }
	unless (defined $main::config{HOMEURL}) { $main::config{HOMEURL} = 'HOME'; }
	unless (defined $main::config{TOPURL}) { $main::config{TOPURL} = 'TOP'; }
	unless (defined $main::config{SRCURL}) { $main::config{SRCURL} = 'SRC'; }
	unless (defined $main::config{IMAGETYPE}) { $main::config{IMAGETYPE} = 'PNG'; }
	unless (defined $main::config{HTMLREFRESH}) { $main::config{HTMLREFRESH} = 300; }
	unless (defined $main::config{UPTIMEFLAG}) {
		$main::config{UPTIMEFLAG} = '&nbsp;<span style="background-color: red">*</span>';
	}
	unless (defined $main::config{HTML}{ALERTFLAGWARN}) {
		$main::config{HTML}{ALERTFLAGWARN} = '&nbsp;<span CLASS="WARN">A</span>';
	}
	unless (defined $main::config{HTML}{ALERTFLAGERROR}) {
		$main::config{HTML}{ALERTFLAGERROR} = '&nbsp;<span CLASS="ERROR">A</span>';
	}
	unless (defined $main::config{HTML}{ALERTFLAGCRITICAL}) {
		$main::config{HTML}{ALERTFLAGCRITICAL} = '&nbsp;<span CLASS="CRITICAL">A</span>';
	}
	unless (defined $main::config{HTML}{INDEXPREFIX}) {
		$main::config{HTML}{INDEXPREFIX} = ' ';
	}
	unless (defined $main::config{HTML}{INDEXSUFFIX}) {
		$main::config{HTML}{INDEXSUFFIX} = ' ';
	}
	unless (defined $main::config{HTML}{GROUPPREFIX}) {
		$main::config{HTML}{GROUPPREFIX} = 
			'<TABLE WIDTH="100%"><TR><TD BGCOLOR="#DDDDDD"><FONT="+2"><B>';
	}
	unless (defined $main::config{HTML}{GROUPSUFFIX}) {
		$main::config{HTML}{GROUPSUFFIX} = 
			'</B></FONT></TD></TR></TABLE>' . "\n";
	}
	unless (defined $main::config{HTML}{TOOLPREFIX}) {
		$main::config{HTML}{TOOLPREFIX} = ' ';
	}
	unless (defined $main::config{HTML}{TOOLSUFFIX}) {
		$main::config{HTML}{TOOLSUFFIX} = ' ';
	}
	unless (defined $main::config{HTML}{HOSTPREFIX}) {
		$main::config{HTML}{HOSTPREFIX} = '[';
	}
	unless (defined $main::config{HTML}{HOSTSUFFIX}) {
		$main::config{HTML}{HOSTSUFFIX} = ']';
	}
	unless (defined $main::config{HTML}{LINKPREFIX}) {
		$main::config{HTML}{LINKPREFIX} = ' ';
	}
	unless (defined $main::config{HTML}{LINKSUFFIX}) {
		$main::config{HTML}{LINKSUFFIX} = ' ';
	}
	unless (defined $main::config{HTML}{OUTOFRANGEPREFIX}) {
		$main::config{HTML}{OUTOFRANGEPREFIX} = '<SPAN STYLE="background-color:yellow">';
	}
	unless (defined $main::config{HTML}{OUTOFRANGESUFFIX}) {
		$main::config{HTML}{OUTOFRANGESUFFIX} = '</SPAN>';
	}

$errors;
}

#------------------------------------------------- read_config_times ---
sub read_config_times {
	my ($configdir) = @_;
	my $configfile = $configdir .'/times';
	my ($name, $value, $errors, $start, $finish);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_times: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading times configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $start, $finish) = split(' ', $_, 3);
		if ($start =~ /^\s*([-0-9\* ]+)\s*$/) {
			$start = eval $1;
		}
		else {
			++$errors;
			&error("read_config_times: start expression invalid: $start");
			next;
		}
		if ($finish =~ /^\s*([-0-9\* ]+)\s*$/) {
			$finish = eval $1;
		}
		else {
			++$errors;
			&error("read_config_times: finish expression invalid: $finish");
			next;
		}
		$main::config{TIME}{$name}{START} = $start;
		$main::config{TIME}{$name}{FINISH} = $finish;
		&debug("  $name start=$main::config{TIME}{$name}{START}, " .
			"finish=$main::config{TIME}{$name}{FINISH}") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{TIME}) {
		&errors("read_config_times: missing times config-file");
		++$errors;
	}

$errors;
}

#------------------------------------------------- read_config_colors ---
sub read_config_colors {
	my ($configdir) = @_;
	my $configfile = $configdir .'/colors';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_colors: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading colors configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		$name = uc $name;
		$main::config{COLOR}{$name} = $value;
		&debug("  $name value='$value'") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{COLOR}) {
		&error("read_config_colors: missing colors config-file");
		++$errors;
	}

$errors;
}

#------------------------------------------------- read_config_archives ---
sub read_config_archives {
	my ($configdir) = @_;
	my $configfile = $configdir .'/archives';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_archives: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading archives configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		$main::config{ARCHIVE}{$name} = $value;
		&debug("  $name value='$value'") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{ARCHIVE}) {
		&error("read_config_archives: missing archives config-file");
		++$errors;
	}

$errors;
}

#------------------------------------------------- read_config_links ---
sub read_config_links {
	my ($configdir) = @_;
	my $configfile = $configdir .'/links';
	my ($name, $value, $errors);
	$errors = 0;

	unless (-f $configfile or -l $configfile) {
		&debug("no links config-file; skipped") if ($main::config_debug);
		return 0;
	}

	open (CONFIG, "<$configfile") or do {
		&error("read_config_links: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading links configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		push @{$main::config{LINKS}}, {NAME => $name, URL => $value};
	}
	close (CONFIG);

	unless (defined $main::config{LINKS}) {
		&debug("missing links config-file; skipped") if ($main::config_debug);
	}
$errors;
}

#------------------------------------------------- read_config_tools ---
sub read_config_tools {
	my ($configdir) = @_;
	my $configfile = $configdir .'/tools';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_tools: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading tools configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		$main::config{TOOL}{$name} = $value;
		&debug("  $name value='$value'") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{TOOL}) {
		&error("read_config_tools: missing tools config-file; skipped");
	}

$errors;
}

#------------------------------------------------- read_config_remotepings ---
sub read_config_remotepings {
	my ($configdir) = @_;
	my $configfile = $configdir .'/remotepings';
	my ($name, $value, $errors);
	$errors = 0;

	unless (-f $configfile or -l $configfile) {
		&debug("no remotepings config-file; skipped") if ($main::config_debug);
		return 0;
	}

	open (CONFIG, "<$configfile") or do {
		&error("read_config_remotepings: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading remotepings configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);

		if (/^(\S+)\s*$/) {
			$name = $1;
			push @{$main::config{REMOTEPING}}, $name;
		}
		else {
			++$errors;
			&error("read_config_remotepings: unknown line: $_");
			next;
		}
		&debug("  $name") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{REMOTEPING}) {
		&debug("missing remoteping config-file; skipped") if ($main::config_debug);
	}

$errors;
}

#------------------------------------------------- read_config_scripts ---
sub read_config_scripts {
	my ($configdir) = @_;

	unless (-d $configdir .'/scripts' or -l $configdir .'/scripts') {
		&error("read_config_scripts: missing $configdir/scripts config-subdir");
		return 1;
	}

	my @configfiles = &list_files ($configdir .'/scripts');
	my ($name, $value, $errors, $script);
	$errors = 0;

	&debug("") if ($main::config_debug);
	&debug("reading scripts configuration") if ($main::config_debug);

	foreach my $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			++$errors;
			&error("read_config_scripts: can't open $configfile: $!");
			next;
		};
		$script = &basename($configfile);
		if ($script =~ /-$/) { $script .= '*'; } # for wildcard scripts
		while (<CONFIG>) {
			chomp;
			next if (/^#/ or /^\s*$/);
			($name, $value) = split(' ',$_,2);

			if ($name =~ /^(ok|warn|error|critical)$/i) {
				$main::config{SCRIPT}{$script}{uc $name} = $value;
				push @{$main::config{SCRIPT}{$script}{TESTS}}, uc $name;
				&debug("  $name value='$value'") if ($main::config_debug);
			}
			elsif ($name =~ /^(send|timeout|port|proxy|infopattern|valuepattern)$/i) {
				$value =~ s/\\n/\n/g;
				$main::config{SCRIPT}{$script}{uc $name} = $value;
				&debug("  $name value='$value'") if ($main::config_debug);
			}
			else {
				++$errors;
				&error("read_config_scripts: unknown line: $_");
				next;
			}
		}
		if (defined $main::config{SCRIPT}{$script}{TESTS} and not
				defined $main::config{SCRIPT}{$script}{SEND}) {
			++$errors;
			&error("read_config_scripts: script $script has status tests, but no send string");
		}
		close (CONFIG);
	}

	unless (defined $main::config{SCRIPT}) {
		&error("read_config_scripts: missing scripts config-file; skipped");
	}

$errors;
}

#------------------------------------------------- read_config_alerts ---
sub read_config_alerts {
	my ($configdir) = @_;
	my $configfile = $configdir .'/alerts';
	my ($errors);
	my ($level, $host, $realrrd, $var, $mintime, $interval, $prog, @addresses);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_alerts: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading alerts configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);

		($level, $host, $realrrd, $var, $mintime, $interval, $prog, 
			@addresses) = split(' ',$_);
		$level = uc $level;
		if ($level eq '*') { $level = '.*'; }
		if ($host eq '*') { $host = '.*'; }
		if ($realrrd eq '*') { $realrrd = '.*'; }
		if ($var eq '*') { $var = '.*'; }
		push @{$main::config{ALERT}} , {
				LEVEL => $level,
				HOST => $host,
				RRD => $realrrd,
				VAR => $var,
				MINTIME => $mintime,
				INTERVAL => $interval,
				PROG => $prog,
				ADDRESSES => [ @addresses ],
			};
		&debug("  level=$level, host=$host, rrd=$realrrd, var=$var, " .
			"mintime=$mintime, interval=$interval, prog='$prog', " .
			"addresses=".join(',',@addresses)) if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{ALERT}) {
		&error("read_config_alerts: missing alerts config-file; skipped");
	}

$errors;
}

#------------------------------------------------- read_config_oids ---
sub read_config_oids {
	my ($configdir) = @_;
	my $configfile = $configdir .'/oids';
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_oids: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading oids configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		$main::config{OID}{$name} = $value;
		&debug("  oid $name = $value") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{OID}) {
		&error("read_config_oids: missing oids config-file; skipped");
	}

$errors;
}

#------------------------------------------------- read_config_rrds ---
sub read_config_rrds {
	my ($configdir) = @_;
	my $errors = 0;
	
	unless (-d $configdir .'/rrds' or -l $configdir .'/rrds') {
		&error("read_config_rrds: missing $configdir/rrds config-subdir");
		return 1;
	}

	my @configfiles = &list_files ($configdir .'/rrds');
	my ($collector, $name, $alias, $ds, $extra, $var, $relation, $values,
		$port, $oidname, $fulloidname, $statusfile, $variables, $graph,
		$wildrrd, $real_collector, $sub_collector, $status);

	&debug("") if ($main::config_debug);
	&debug("reading rrds configuration") if ($main::config_debug);

	foreach my $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			&error("read_config_rrds: can't open $configfile: $!");
			next;
		};
		$wildrrd = &basename($configfile);
		&debug("") if ($main::config_debug);
		&debug("rrd $wildrrd") if ($main::config_debug);
		if (substr($wildrrd,length($wildrrd)-1) eq '-') {
			$wildrrd .= '*';
			&debug("  wildcard '*' added") if ($main::config_debug);
		}
		while (<CONFIG>) {
			chomp;
			next if (/^#/ or /^\s*$/);

			if (/^step\s+(\d+)\s*$/i) {
				$main::config{RRD}{$wildrrd}{STEP} = $1;
				&debug("  step $1") if ($main::config_debug);
			}
			elsif (/^source\s+(\S+)\s*$/i) {
				$collector = $1;
				($real_collector, $sub_collector) = split('\s*=\s*', $collector,2);
				$main::config{RRD}{$wildrrd}{SOURCE} = $real_collector;
				if (defined $sub_collector) {
					$main::config{COLLECTOR}{$real_collector}{$wildrrd} = $sub_collector;
				}
				else { $main::config{COLLECTOR}{$real_collector}{$wildrrd} = 1; }
				&debug("  source $collector") if ($main::config_debug);
			}
			elsif (/^data\s+(\S+)\s+(\S+)(\s+(.*))?$/i) {
				($name, $alias) = split('=',$1,2);
				$name = lc $name;
				unless (defined $alias) { $alias = $name; }
				$alias = lc $alias;
				$ds = $2;
				$extra = $4;

				$main::config{RRD}{$wildrrd}{$name}{ALIAS} = $alias;
				$main::config{RRD}{$wildrrd}{$name}{DS} = $ds;
				$main::config{RRD}{$wildrrd}{$name}{EXTRA} = $extra
					unless (defined $extra and
						$extra =~ /^\s*$/);
				push @{$main::config{RRD}{$wildrrd}{DATANAMES}}, 
					$name;
				&debug("  data name=$name, alias=$alias, ds=$ds, extra=". 
					((defined $extra) ? $extra : '-undefined-')) 
					if ($main::config_debug);
			}
			elsif (/^archives\s+(.*)/i) {
				$main::config{RRD}{$wildrrd}{ARCHIVES} = 
					[split(' ',$1)];
				&debug("  archives $1") if ($main::config_debug);
			}
			elsif (/^times\s+(.*)/i) {
				$main::config{RRD}{$wildrrd}{TIMES} = 
					[split(' ',$1)];
				&debug("  times $1") if ($main::config_debug);
			}
			elsif (/^alert\s+([a-z0-9_]+)\s+([<=>]|delta[<>]|>(day|week|month)stddev)\s+(\d+(\s+\d+){0,2})/i) {
				($var, $relation, $values) =
					($1, $2, $4);
				unless (defined $main::config{RRD}{$wildrrd}{$var}) {
					++$errors;
					&error("read_config_rrds($wildrrd): unknown variable ($var) in rrd $wildrrd: $_");
					next;
				}
				$main::config{RRD}{$wildrrd}{ALERT}{$var}{RELATION} = $relation;
				@{$main::config{RRD}{$wildrrd}{ALERT}{$var}{VALUES}} = split(' ',$values);
				&debug("  alert var=$var, rel=$relation, val=$values") if ($main::config_debug);
			}
			elsif (/^alert\s+([a-z0-9_]+)\s+nodata\s+(\S+)/i) {
				($var, $status) = ($1, uc $2);
				unless (defined $main::statuses{$status}) {
					&error("read_config_rrds($wildrrd): unknown status for nodata alert '$status' for rrd $wildrrd");
					++$errors;
					next;
				}
				$status = $main::statuses{$status};
				$main::config{RRD}{$wildrrd}{$var}{NODATA} = $status;
				&debug("  alert $wildrrd $var nodata $status") 
					if ($main::config_debug);
			}
			elsif (/^port\s+(\d+)\s*$/i) {
				$port = $1;
				$main::config{RRD}{$wildrrd}{PORT} = $port;
				&debug("  port $port") if ($main::config_debug);
			}
			elsif (/^oid\s+(\S+)\s*$/i) {
				$fulloidname = $1;
				($oidname) = split('\.',$fulloidname,2);
				if (defined $main::config{OID}{$oidname}) {
					push @{$main::config{RRD}{$wildrrd}{OIDS}}, $fulloidname; # need the name
				}
				else {
					++$errors;
					&error("read_config_rrds($wildrrd): unknown OID name ($oidname) for rrd $wildrrd");
					next;
				}
			}
			elsif (/^statusfile\s+([-a-zA-Z0-9._]+)\s+(.+)$/i) {
				$statusfile = $1;
				$variables = $2;
				$main::config{RRD}{$wildrrd}{STATUSFILE}{$statusfile} = $variables;
				&debug("  statusfile $statusfile $variables") if ($main::config_debug);
			}
			elsif (/^available\s+(.+?)\s*$/i) {
				$main::config{RRD}{$wildrrd}{AVAILABLE} = $1;
				&debug("  available $1") if ($main::config_debug);
			}
			elsif (/^graph\s+(\S+)(\s+desc=('([^']+)'|"([^"]+)"))?\s*$/i) {
				$graph = $1;
				if (defined $4) { $main::config{RRD}{$wildrrd}{GRAPHDESC}{$graph} = $4; }
				elsif (defined $5) { $main::config{RRD}{$wildrrd}{GRAPHDESC}{$graph} = $5; }
				push @{$main::config{RRD}{$wildrrd}{GRAPHS}}, $graph;
				&debug("  graph $graph") if ($main::config_debug);
			}
			elsif (/\s+(.*)/) { # graph continuation
				&debug("    make_array adding to graph $graph") if ($main::config_debug);
				push @{$main::config{RRD}{$wildrrd}{GRAPH}{$graph}}, &make_array($1);
				&debug("    $1") if ($main::config_debug);
			}
			else {
				++$errors;
				&error("read_config_rrds($wildrrd): unknown line: $_");
				next;
			}
		}
		close (CONFIG);
	}

	unless (defined $main::config{RRD}) {
		&error("read_config_rrds: missing rrd config-files");
		++$errors;
	}

$errors;
}

#------------------------------------------------- read_config_customgraphs ---
sub read_config_customgraphs {
	my ($configdir) = @_;

	unless (-d $configdir .'/customgraphs' or -l $configdir .'/customgraphs') {
		&error("read_config_customgraphs: missing $configdir/customgraphs config-subdir");
		return 1;
	}

	my @configfiles = &list_files( $configdir .'/customgraphs');
	my ($name, $value, $errors, $customgraph);
	$errors = 0;

	&debug("") if ($main::config_debug);
	&debug("reading customgraphs configuration") if ($main::config_debug);

	foreach my $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			&error("can't open $configfile: $!");
			++$errors;
			next;
		};
		$customgraph = &basename($configfile);
		&debug("customgraph $customgraph") if ($main::config_debug);
		push @{$main::config{CUSTOMGRAPHS}}, $customgraph;
		while (<CONFIG>) {
			chomp;
			next if (/^#/ or /^\s*$/);
			($name, $value) = split(' ',$_,2);

			if (/^desc\s+(.*)$/i) {
				$main::config{CUSTOMGRAPH}{$customgraph}{DESC} = $1;
				&debug("  desc = $1") if ($main::config_debug);
			}
			elsif (/^times\s+(.*)/i) {
				@{$main::config{CUSTOMGRAPH}{$customgraph}{TIMES}} = split(' ',$1);
				&debug("  times = $1") if ($main::config_debug);
			}
			elsif (/^\s+(.*)/i) {
				push @{$main::config{CUSTOMGRAPH}{$customgraph}{GRAPH}}, &make_array($1);
				&debug("    $1") if ($main::config_debug);
			}
			else {
				++$errors;
				&error("read_config_customgraphs($customgraph): unknown line: $_");
			}
		}
		close (CONFIG);
	}

	unless (defined $main::config{CUSTOMGRAPH}) {
		&debug("missing customgraphs config-files;skipped") if ($main::config_debug);;
	}

$errors;
}

#------------------------------------------------- read_config_hosts ---
sub read_config_hosts {
	my ($configdir, $dir, $key) = @_;
	my $singular;
	if ($dir =~ /(.*)s$/) { $singular = $1; }
	else { $singular = $dir; }

	my $hosts_config_dir = $configdir .'/'. $dir;
	unless (-d $hosts_config_dir or -l $hosts_config_dir) {
		&error("read_config_hosts: missing $hosts_config_dir config-subdir");
		return 1;
	}

	my @configfiles = &list_files( $hosts_config_dir);
	my ($name, $value, $errors, $group, $tmp, @aliases, $lat, $lon, $desc,
		$email, $realrrd, $extra, $wildrrd, $collector, $graph,
		$var, $relation, $values, @tags, $host, $rrddesc, $port, $status,
		$ntserver, $template);
	$errors = 0;

	&debug("") if ($main::config_debug);
	&debug("reading $dir configuration") if ($main::config_debug);

	foreach my $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			&error("read_config_hosts: can't open $configfile: $!");
			++$errors;
			next;
		};
		$host = &basename($configfile);
		&debug("") if ($main::config_debug);
		&debug("$singular $host") if ($main::config_debug);
		while (<CONFIG>) {
			chomp;
			next if (/^#/ or /^\s*$/);
			($name, $value) = split(' ',$_,2);
		
			if (/^ip\s+(\d+\.\d+\.\d+\.\d+)\s*$/i) {
				$main::config{$key}{$host}{IP} = $1 if ($key eq 'HOST');
				&debug("  ip $1") if ($main::config_debug);
			}

# FIX
# This needs to get propagated into hosts which use host-templates.  Without it
# host templates won't work.
			elsif (/^group\s+(.*)\s*$/i) {
				($group = $1) =~ s/\s*$//;
				unless (grep /^$group$/, @{$main::config{GROUPS}}) {
					++$errors;
					&error("read_config_hosts($dir): $host wants to be in group $group, ".
					"but that's not listed in groups");
				}
				$main::config{$key}{$host}{GROUP} = $group;
				push @{$main::config{GROUP}{$group}}, $host if ($key eq 'HOST');
				$main::config{TEMPLATEGROUP}{$host} = $group if ($key eq 'HOSTTEMPLATE');
				&debug("  group $group") if ($main::config_debug);
			}
			elsif (/^desc\s+(.*)\s*$/i) {
				$main::config{$key}{$host}{DESC} = $1;
				&debug("  desc $1") if ($main::config_debug);
			}
			elsif (/^community\s+(\S+)\s*$/i) {
				$main::config{$key}{$host}{COMMUNITY} = $1;
				&debug("  community $1") if ($main::config_debug);
			}
			elsif (/^via\s+(.*)\s*$/i) {
				$main::config{$key}{$host}{VIA} = $1;
				$main::config{$key}{$host}{VIA} =~ s/\s+$//;
				&debug("  via $1") if ($main::config_debug);
			}
			elsif (/^alias(es)?\s+(.*)\s*$/i) {
				($tmp = $2) =~ s/\s+$//;
				@aliases = split(' ', $2);
				push @{$main::config{$key}{$host}{ALIASES}}, @aliases
			}
			elsif (/^location\s+([-+]?\d+(\.\d+)?[NS]?)\s+([-+]?\d+(\.\d+)?[EW]?)\s+(.*)/i) {
				$lat = $1; $lon = $3; $desc = $5;
				$main::config{$key}{$host}{LOCATION} = 
					[$lat, $lon, $desc];
				&debug("  location lat=$lat, lon=$lon, desc=$desc") 
					if ($main::config_debug);
			}
			elsif (/^contact\s+([^<]+)\s+<(.*)>/i) {
				$name = $1;
				$email = $2;
				$main::config{$key}{$host}{CONTACTNAME} = $name;
				$main::config{$key}{$host}{CONTACTEMAIL} = $email;
				&debug("  contact name='$name', email='$email'") 
					if ($main::config_debug);
			}
			elsif (/^rrd\s+(\S+)(\s+(.*))?$/i) {
				$realrrd = $1;
				$extra = $3;
				push @{$main::config{$key}{$host}{RRDS}}, $realrrd;
				if (defined $extra and $extra =~ 
						/\bdesc\s*=\s*('([^']+)'|"([^"]+)")/i) {
					if (defined $2) { $rrddesc = $2; }
					elsif (defined $3) { $rrddesc = $3; }
					else { &abort("read_config_hosts($dir): rrddesc: can't happen: $_"); }
					$main::config{$key}{$host}{RRDDESC}{$realrrd} = $rrddesc;
					$extra =~ s/\bdesc\s*=\s*('[^']+'|"[^"]+")//i;
					if ($extra =~ /^\s*$/) { undef $extra; }
				}
				unless (defined $extra and $extra =~ /^\s*$/) {
					$main::config{$key}{$host}{EXTRA}{$realrrd} = $extra;
				}
				($wildrrd) = &get_rrd($realrrd);
				$collector = $main::config{RRD}{$wildrrd}{SOURCE};

# FIX
# This needs to get propagated into hosts which use host-templates.  Without it
# host templates won't work.
				$main::config{HOSTCOLLECTEDBY}{$collector}{$host} = 1 if ($key eq 'HOST');
				$main::config{TEMPLATECOLLECTEDBY}{$host}{$collector} = 1 
					if ($key eq 'HOSTTEMPLATE');
				&debug("  rrd $realrrd, extra=" .
					((defined $extra) ? $extra : '-undefined-')) if ($main::config_debug);
			}
			elsif (/^nograph\s+(\S+)\s+(\S+)\s*$/i) {
				$realrrd = $1;
				$graph = $2;
				unless (defined $main::config{RRD}{$realrrd}) {
					++$errors;
					&error("read_config_hosts($dir): $host: no such rrd in: $_");
				}
				$main::config{$key}{$host}{NOGRAPH}{$realrrd}{$graph} = 1;
				&debug("  nograph $realrrd $graph") if ($main::config_debug);
			}
			elsif (/^tools\s+(.*)$/i) {
				@{$main::config{$key}{$host}{TOOLS}} = split(' ',$1);
				&debug("  tools $1") if ($main::config_debug);
			}
			elsif (m#^alert\s+([-a-z0-9:/._]+)\s+([a-z0-9_]+)\s+([<=>])\s+(\d+(\s+\d+){0,2})\s*$#i) {
				($realrrd, $var, $relation, $values) = ($1, $2, $3, $4);
				($wildrrd) = &get_rrd($realrrd);
				unless (defined $main::config{$key}{$host}{RRDS} and
						grep (/^$realrrd$/, 
						@{$main::config{$key}{$host}{RRDS}})) {
					++$errors;
					&error("read_config_hosts($dir): $host: unknown rrd $realrrd: $_");
					next;
				}
				unless (defined $main::config{RRD}{$wildrrd}{$var}) {
					++$errors;
					&error("read_config_hosts($dir): $host: unknown variable ($var) in rrd $wildrrd: $_");
					next;
				}
				$main::config{$key}{$host}{ALERT}{$realrrd}{$var}{RELATION} = $relation;
				@{$main::config{$key}{$host}{ALERT}{$realrrd}{$var}{VALUES}} = split(' ',$values);
				&debug("  alert $realrrd $var $relation $values")
					if ($main::config_debug);
			}
			elsif (m#^alert\s+([-a-z0-9:/._]+)\s+([a-z0-9_]+)\s+nodata\s+(\S+)#i) {
				($realrrd, $var, $status) = ($1, $2, uc $3);
				($wildrrd) = &get_rrd($realrrd);
				unless (defined $main::config{$key}{$host}{RRDS} and
						grep (/^$realrrd$/, 
						@{$main::config{$key}{$host}{RRDS}})) {
					++$errors;
					&error("read_config_hosts($dir): $host: unknown rrd $realrrd: $_");
					next;
				}
				unless (defined $main::config{RRD}{$wildrrd}{$var}) {
					++$errors;
					&error("read_config_hosts($dir): $host: unknown variable ".
						"($var) in rrd $wildrrd: $_");
					next;
				}
				unless (defined $main::statuses{$status}) {
					&error("read_config_rrds($dir): $host: unknown status for ".
						"nodata alert for host $host rrd $realrrd '$status'");
					++$errors;
					next;
				}
				$status = $main::statuses{$status};
				$main::config{$key}{$host}{ALERT}{$realrrd}{$var}{NODATA} = $status;
				&debug("  alert $host $realrrd $var nodata $status") 
					if ($main::config_debug);
			}
			elsif (m#^noalert\s+([-a-z0-9:/._]+)\s+([a-z0-9_]+)\s*$#i) {
				($realrrd, $var) = ($1, $2);
				$main::config{$key}{$host}{ALERT}{$realrrd}{$var}{NOALERT} = 1;
				&debug("  noalert for $realrrd $var") if ($main::config_debug);
			}
			elsif (/^snmpport\s+(\d+)\s*$/i) {
				$port = $1;
				$main::config{$key}{$host}{SNMPPORT} = $port;
				&debug("  snmpport $port") if ($main::config_debug);
			}
			elsif (/^tags\s+([-a-zA-Z_0-9]+)(\s+([[-a-zA-Z_0-9]+))*\s*$/) {
				my @tags;
				push @tags, $1;
				if (defined $2) { push @tags, split(' ',$2); }
				foreach my $tag (@tags) {
					next if (length($tag) == 0);
					$main::config{$key}{$host}{TAG}{$tag} = 1;
				}
				&debug("  tags @tags") if ($main::config_debug);
			}
			elsif (/^customgraph\s+(\S+)\s*$/) {
				push @{$main::config{$key}{$host}{CUSTOMGRAPHS}}, $1;
				&debug("  customgraph $1") if ($main::config_debug);
			}
			elsif (/^statusfile\s+(\S+)\s*$/) {
				$main::config{$key}{$host}{STATUSFILE} = $1;
				&debug("  statusfile $1") if ($main::config_debug);
			}

# FIX
# This needs to get propagated into hosts which use host-templates.  Without it
# host templates won't work.
			elsif (/^nt-status-server\s+(\S+)/i) {
				$ntserver = $1;
				$main::config{$key}{$host}{NTSTATUSSERVER} = $ntserver;
				push @{$main::config{$key}{$ntserver}{NTINDIRECTHOSTS}}, $host;
				&debug("  nt-status-server $ntserver") if ($main::config_debug);
			}
			elsif (/^ntname\s+(\S+)/) {
				$ntserver = $1;
				$main::config{$key}{$host}{NTNAME} = $ntserver;
				&debug("  ntname $ntserver") if ($main::config_debug);
			}
			elsif (/^template\s+(\S+)/) {
				$template = $1;
				&debug("  template $template") if ($main::config_debug);
				if (defined $main::config{HOSTTEMPLATE}{$template}) {
					&copy_host_template( \%{$main::config{$key}{$host}}, 
						\%{$main::config{HOSTTEMPLATE}{$template}}, 
						$template, $host);
				}
				else {
					&error("read_config_hosts($dir): $host: unknown template $template");
					++$errors;
				}
			}
			elsif (/^noavailability\s+(\S+)\s+(\S+)\s*$/) {
				$realrrd = $1;
				$var = $2;
				$main::config{$key}{$host}{NOAVAILABILITY}{$realrrd}{$var} = 1;
				&debug("  noavailability $realrrd $var") if ($main::config_debug);
			}
			elsif ($name eq 'showinterfaces') {
				if ($value =~ /^(yes|y|true|t|1)|(no|n|false|f|0)$/i) {
					$value = (defined $1) ? 1 : 0;
				}
				else {
					&error("read_config_hosts($$dir): $host: showinterfaces must be yes or no");
					++$errors;
					next;
				}
				$main::config{HOST}{$host}{SHOWINTERFACES} = $value;
			}
			else {
				++$errors;
				&error("read_config_hosts($dir): $host: unknown line: $_");
				next;
			}
		}
		close (CONFIG);
	}

	if ($key eq 'HOST' and !defined $main::config{$key}) {
		&error("read_config_hosts($dir): missing config-files");
		++$errors;
	}
	elsif ($key eq 'HOSTTEMPLATE' and !defined $main::config{$key}) {
		&debug("missing $dir config-files; skipped") if ($main::config_debug);
	}

$errors;
}

#------------------------------------------------- copy_host_template ---
sub copy_host_template {
	my ($hashref1, $hashref2, $template, $host) = @_;
	my ($key, $group, $ntserver);

	foreach $key (keys %{$hashref2}) {
		$$hashref1{$key} = $$hashref2{$key};
		&debug("    copied $key") if ($main::config_debug);
	}

# Now the more difficult parts: side-effects in other parts of the config structure

# Propagate the effect of group:
#	$main::config{$key}{$host}{GROUP} = $group;
#	push @{$main::config{GROUP}{$group}}, $host if ($key eq 'HOST');
#	$main::config{TEMPLATEGROUP}{$host} = $group if ($key eq 'HOSTTEMPLATE');

	if (defined $main::config{TEMPLATEGROUP}{$template}) {
		$group = $main::config{TEMPLATEGROUP}{$template};
		push @{$main::config{GROUP}{$group}}, $host;
		&debug("    propagate GROUP group=$group, host=$host")
			if ($main::config_debug);
	}

# Propagate the effect of rrd collectors:
#	$main::config{HOSTCOLLECTEDBY}{$collector}{$host} = 1 if ($key eq 'HOST');
#	$main::config{TEMPLATECOLLECTEDBY}{$host}{$collector} = 1 if ($key eq 'HOSTTEMPLATE');

	foreach $key (keys %{$main::config{TEMPLATECOLLECTEDBY}{$template}}) {
		$main::config{HOSTCOLLECTEDBY}{$key}{$host} = 1;
		&debug("    propagate HOSTCOLLECTEDBY collector=$key, host=$host")
			if ($main::config_debug);
	}

# Propagate the effect of indirect nt-status-server:
#	$main::config{$key}{$host}{NTSTATUSSERVER} = $ntserver;
#	push @{$main::config{$key}{$ntserver}{NTINDIRECTHOSTS}}, $host;

	if (defined $main::config{HOSTTEMPLATE}{$template}{NTSTATUSSERVER}) {
		$ntserver = $main::config{HOSTTEMPLATE}{$template}{NTSTATUSSERVER};
		push @{$main::config{HOST}{$ntserver}{NTINDIRECTHOSTS}}, $host;
		&debug("    propagate NTINDIRECTHOSTS ntserver=$ntserver, host=$host")
			if ($main::config_debug);
	}
}

#------------------------------------------------- read_config_groups ---
sub read_config_groups {
	my ($configdir) = @_;
	my $configfile = $configdir .'/groups';
	my %config = ();
	my ($name, $value, $errors, $group);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_groups: can't open $configfile: $!");
		return 1;
	};
	
	&debug("") if ($main::config_debug);
	&debug("reading groups configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		$group = $_;
		$group =~ s/^\s+//;
		$group =~ s/\s+$//;
		push @{$main::config{GROUPS}}, $group;
		&debug("  added group '$group'") if ($main::config_debug);
	}
	close (CONFIG);

	unless (defined $main::config{GROUPS}) {
		&error("read_config_groups: missing groups config-file");
		++$errors;
	}

$errors;
}

#---------------------------------------- read_config_view_templates ---
sub read_config_view_templates {
	my ($configdir) = @_;
	my ($name, $value, $errors, $configfile, $template, $text);
	$errors = 0;

	unless (-d $configdir .'/view-templates' or -l $configdir .'/view-templates') {
		&error("read_config_view_templates: missing $configdir/view-templates config-subdir");
		return 1;
	}
	
	&debug("") if ($main::config_debug);
	&debug("reading view-templates configuration") if ($main::config_debug);

	my @configfiles = &list_files( $configdir .'/view-templates');
	foreach $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			&error("read_config_view_templates: can't open $configfile: $!");
			return 1;
		};
		$template = &basename($configfile);
		&debug("") if ($main::config_debug);
		&debug("view-template $template") if ($main::config_debug);

		$text = '';
		while (<CONFIG>) {
			$text .= $_;
		}
		close (CONFIG);
		$main::config{VIEWTEMPLATE}{$template} = $text;

		unless (defined $main::config{VIEWTEMPLATE}) {
			&error("read_config_view_templates: no view-templates config-files; skipped");
		}
	}

$errors;
}

#------------------------------------------------- read_config_views ---
sub read_config_views {
	my ($configdir) = @_;
	my %config = ();
	my ($name, $value, $errors, $configfile, $view);
	$errors = 0;

	unless (-d $configdir .'/views' or -l $configdir .'/views') {
		&error("read_config_views: missing $configdir/views config-subdir");
		return 1;
	}
	&debug("") if ($main::config_debug);
	&debug("reading views configuration") if ($main::config_debug);

	my @configfiles = &list_files( $configdir .'/views');
	foreach $configfile (@configfiles) {
		open (CONFIG, "<$configfile") or do {
			&error("read_config_views: can't open $configfile: $!");
			return 1;
		};
		$view = &basename($configfile);
		&debug("") if ($main::config_debug);
		&debug("view $view") if ($main::config_debug);

		while (<CONFIG>) {
			chomp;
			next if (/^#/ or /^\s*$/);
			
			if (/^desc(ription)?\s+(.*)/i) {
				$main::config{VIEW}{$view}{DESC} = $2;
				&debug("  desc $2") if ($main::config_debug);
			}
			elsif (/^graph\s+(\S+)\s+(\S+)\s+(\S+)\s*$/i) {
				push @{$main::config{VIEW}{$view}{GRAPHS}}, "graph $1 $2 $3";
				&debug("  graph $1 $2 $3") if ($main::config_debug);
			}
			elsif (/^customgraph\s+(\S+)\s*$/i) {
				push @{$main::config{VIEW}{$view}{GRAPHS}}, 
					"customgraph $1";
				&debug("  customgraph $1") if ($main::config_debug);
			}
			elsif (/^template\s+(\S+)\s*$/i) {
				unless (defined $main::config{VIEWTEMPLATE}{$1}) {
					&error("read_config_views: $view: no such view template as '$1'; ignored");
					next;
				}
				$main::config{VIEW}{$view}{TEMPLATE} = $1;
				&debug("  template $1") if ($main::config_debug);
			}
			elsif (/^datapage\s+(\S+)\s*$/i) {
				$main::config{VIEW}{$view}{DATAPAGE} = $1;
				&debug("  datapage $1") if ($main::config_debug);
			}
			else {
				&error("read_config_views: $view: unknown line: $_");
				++$errors;
				next;
			}
		}
		close (CONFIG);

		if (((defined $main::config{VIEW}{$view}{GRAPHS} or 
				defined $main::config{VIEW}{$view}{CUSTOMGRAPHS}) and
				(defined $main::config{VIEW}{$view}{TEMPLATE} or
				defined $main::config{VIEW}{$view}{DATAPAGE})) or
				(defined $main::config{VIEW}{$view}{TEMPLATE} and
				defined $main::config{VIEW}{$view}{DATAPAGE})
				) {
			&error("read_config_views: $view: a view can have graphs/customgraphs or template or datapage");
			++$errors;
		}
		unless (defined $main::config{VIEW}) {
			&error("read_config_views: missing view config-file; skipped");
		}
	}

$errors;
}

#------------------------------------------------- read_config_alert_template_map ---
sub read_config_alert_template_map {
	my ($configdir) = @_;
	my $configfile = $configdir .'/alert-template-map';
	my %config = ();
	my ($what, $name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_alert_template_map: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading alert-template-map configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		if (/^(rrd|address)\s+(\S+)\s+(\S+)\s*$/) {
			$what = uc $1;
			$name = $2;
			$value = $3;
			$main::config{ALERTTEMPLATE}{$what}{$name} = $value;
			&debug("  $1 $2 $3") if ($main::config_debug);
		}
		else {
			&error("read_config_alert_template_map: unknown line: $_; skipped");
			++$errors;
		}
	}
	close (CONFIG);

$errors;
}

#------------------------------------------------- read_config_availability ---
# read availibility configuration
sub read_config_availability {
	my ($configdir) = @_;
	my $configfile = $configdir .'/availability';
	my ($errors, $host, $rrd, $varname, $cf, $relation, $threshold);
	$errors = 0;

	unless (-f $configfile or -l $configfile) {
		&debug("no availability config-file; skipped") if ($main::config_debug);
		return 0;
	}
	open (CONFIG, "<$configfile") or do {
		&error("read_config_availability: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading availability configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		if (/^\s*rrd\s+(\S+)\s+(\S+)\s+(LAST|MIN|MAX|AVERAGE)\s+(<|<=|>|>=|=)\s+([-+]?\d+(\.\d+)?)\s*$/) {
			($rrd, $varname, $cf, $relation, $threshold) = ($1, $2, $3, $4, $5);
			$main::config{RRDAVAIL}{$rrd}{$varname}{CF} = $cf;
			$main::config{RRDAVAIL}{$rrd}{$varname}{RELATION} = $relation;
			$main::config{RRDAVAIL}{$rrd}{$varname}{THRESHOLD} = $threshold;
			&debug("  rrd $rrd $varname $relation $threshold")
				if ($main::config_debug);
		}
		elsif (/^\s*host\s+(\S+)\s+(\S+)\s+(\S+)\s+(LAST|MIN|MAX|AVERAGE)\s+(<|<=|>|>=|=)\s+([-+]?\d+(\.\d+)?)\s*$/) {
			($host, $rrd, $varname, $cf, $relation, $threshold) = ($1, $2, $3, $4, $5, $6);
			$main::config{HOSTAVAIL}{$host}{$rrd}{$varname}{CF} = $cf;
			$main::config{HOSTAVAIL}{$host}{$rrd}{$varname}{RELATION} = $relation;
			$main::config{HOSTAVAIL}{$host}{$rrd}{$varname}{THRESHOLD} = $threshold;
			&debug("  host $host $rrd $varname $relation $threshold")
				if ($main::config_debug);
		}
		elsif (/^colou?rs\s+(.*)$/) {
			my $temp = $1;
			$temp =~ s/\s+$//;
			my @colors = split(' ', $temp);
			$main::config{AVAILCOLORS} = [ @colors ];
			&debug("  colors ". join(' ', @colors)) if ($main::config_debug);
		}
		elsif (/^thresholds\s+(.*)$/) {
			my $temp = $1;
			$temp =~ s/\s+$//;
			my @thresholds = split(' ', $temp);
			$main::config{AVAILTHRESHOLDS} = [ @thresholds ];
			&debug("  thresholds ". join(' ', @thresholds)) if ($main::config_debug);
		}
		else {
			&error("read_config_availability: unknown line: $_");
			++$errors;
			next;
		}
	}
	close (CONFIG);

	unless (defined $main::config{RRDAVAIL} or
			defined $main::config{HOSTAVAIL}) {
		&debug("missing availability config-file; skipped") if ($main::config_debug);
	}

$errors;
}

#------------------------------------------------- read_config_alert_destination_map ---
# To clone a new config section from
sub read_config_alert_destination_map {
	my ($configdir) = @_;
	my $configfile = $configdir .'/alert-destination-map';
	my %config = ();
	my ($dest, $time, $dow, $dom, $mon, $alias, $rest, $method, @temp, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_alert_destination_map: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading alert-destination-map configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);

		if (/^map\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s*$/) {
			($dest, $time, $dow, $dom, $mon, $alias) =
				(lc $1, $2, $3, $4, $5, lc $6);
			push @{$main::config{ALERTDEST}{DEST}}, 
				[ $dest, $time, $dow, $dom, $mon, $alias ];
			&debug("  map $dest $time $dow $dom $mon $alias")
				if ($main::config_debug);
		}
		elsif (/^alias\s+(\S+)\s+(.*)$/) {
			$alias = $1;
			$rest = $2;
			$rest =~ s/\s+$//;
			@temp = split(' ', $rest);
			$main::config{ALERTDEST}{ALIAS}{$alias} =
				[ @temp ];
			&debug("  alias $alias $rest") if ($main::config_debug);
		}
		elsif (/^method\s+(\S+)\s+(.*)$/) {
			$method = $1;
			$rest = $2;
			$rest =~ s/\s+$//;
			$main::config{ALERTDEST}{METHOD}{$method} = $rest;
			&debug("  method $method $rest") if ($main::config_debug);
		}
		else {
			&error("read_config_alert_destination_map: unknown line: $_");
			++$errors;
		}
	}
	close (CONFIG);

	unless (defined $main::config{ALERTDEST}) {
		&error("read_config_alert_destinaion_map: missing config-file");
		++$errors;
	}

$errors;
}

#------------------------------------------------- read_config_discovery ---
# To read discovery related info
sub read_config_discovery {
	my ($configdir) = @_;
	my $configfile = $configdir .'/discovery';
	my %config = ();
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_discovery: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading discovery configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);

		if ($name eq 'nt-status-server') {
			$main::config{DISCOVERY}{NTSTATUSSERVER} = $value;
			&debug("  nt-status-server $value") if ($main::config_debug);
		}
		elsif ($name eq 'ntdomain') {
			$main::config{DISCOVERY}{NTDOMAIN} = $value;
			&debug("  ntdomain $value") if ($main::config_debug);
		}
		elsif ($name eq 'dnsdomain') {
			$main::config{DISCOVERY}{DNSDOMAIN} = $value;
			&debug("  dnsdomain $value") if ($main::config_debug);
		}
		elsif ($name eq 'subnets') {
			$main::config{DISCOVERY}{SUBNETS} = $value;
			&debug("  subnets $value") if ($main::config_debug);
		}
		else {
			&error("read_config_discovery: unknown: $_");
			++$errors;
		}
	}
	close (CONFIG);

	unless (defined $main::config{DISCOVERY}) {
		&error("read_config_discovery: missing config-file");
		++$errors;
# if optional, use the next line instead to the two above
#		&error("read_config_discovery: missing config-file; skipped");
	}

$errors;
}

#------------------------------------------------- read_config_extra ---
# To clone a new config section from
sub read_config_extra {
	my ($configdir) = @_;
	my $configfile = $configdir .'/extra';
	my %config = ();
	my ($name, $value, $errors);
	$errors = 0;

	open (CONFIG, "<$configfile") or do {
		&error("read_config_extra: can't open $configfile: $!");
		return 1;
	};
	&debug("") if ($main::config_debug);
	&debug("reading extra configuration") if ($main::config_debug);

	while (<CONFIG>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		($name, $value) = split(' ',$_,2);
	}
	close (CONFIG);

	unless (defined $main::config{EXTRA}) {
		&error("read_config_extra: missing config-file");
		++$errors;
# if optional, use the next line instead to the two above
		&error("read_config_extra: missing config-file; skipped");
	}

$errors;
}

#----------------------------------------------------------- basename ---
sub basename {
	my ($path) = @_;
	my @temp = split('/', $path);
	my $name = pop @temp;
$name;
}

#------------------------------------------------------------- do_subs ---
sub do_subs {
	my ($rrdfile, $realrrd, $wildpart, $host, $ip, $graph, $graphtime, 
		@args) = @_;
	my ($shorthost, @temp, %map, $sub);
	&debug("do_subs: start args:\n". join("\n", @args)) if ($main::debug>2);

# Optimization hack for constant stuff
	unless (defined %main::constant_subs) {
		$main::constant_subs{HTMLURL} = $main::config{HTMLURL};
		$main::constant_subs{WEBMASTER} = $main::config{WEBMASTER};
		$main::constant_subs{THUMBHEIGHT} = $main::config{THUMBHEIGHT};
		$main::constant_subs{THUMBWIDTH} = $main::config{THUMBWIDTH};
		$main::constant_subs{DATADIR} = $main::config{DATADIR};

		foreach $sub (keys %{$main::config{COLOR}}) {
			$main::constant_subs{$sub} = $main::config{COLOR}{$sub};
		}
	}
	%map = %main::constant_subs;

# Preparation
	if (defined $host) {
		@temp = split('\.', $host);
		$shorthost = shift @temp;
		while ($shorthost =~ /^(www|ftp|mail)\d*$/) {
			last if ($#temp < 0);
			$shorthost = shift @temp;
		}
	}

# Volatile substitutions
	$map{DB} = $rrdfile if (defined $rrdfile);
	$map{RRD} = $realrrd if (defined $realrrd);
	$map{HOST} = $host if (defined $host);
	$map{SHORTHOST} = $shorthost if (defined $shorthost);
	$map{IP} = $ip if (defined $ip);
	$map{GRAPH} = $graph if (defined $graph);
	$map{GRAPHTIME} = $graphtime if (defined $graphtime);
	$map{WILDPART} = $wildpart if (defined $wildpart);
	$map{HOSTDESC} = $main::config{HOST}{$host}{DESC} 
		if (defined $host and defined $main::config{HOST}{$host}{DESC});
	$map{RRDDESC} = $main::config{HOST}{$host}{RRDDESC}{$realrrd} 
		if (defined $host and defined $realrrd and 
		defined $main::config{HOST}{$host}{RRDDESC}{$realrrd});
	$map{EXTRA} = $main::config{HOST}{$host}{EXTRA}{$realrrd}
		if (defined $host and defined $realrrd and
			defined $main::config{HOST}{$host}{EXTRA}{$realrrd});

# This will be the IP# if it's defined, or the hostname if not.
	if (defined $ip) { $map{IPORHOST} = $ip; }
	elsif (defined $host) { $map{IPORHOST} = $host; }

	@args = map{s/##([A-Z0-9]+)##/(defined $map{$1}) ? $map{$1} : '##'.$1.'##'/ge; $_} @args;

	&debug("do_subs: finish args:\n". join("\n", @args)) if ($main::debug>2);
@args;
}

#-------------------------------------------------------------- get_rrd ---
sub get_rrd {
	my ($realrrd) = @_;
	my ($wildrrd, $wildpart, $extra, $fixedrrd);

	if (defined $main::config{RRD}{$realrrd}) {
		$wildrrd = $realrrd;
	}
	else {
		if ($realrrd =~ /^([^-]+)-(\S+)$/) {
			$wildrrd = $1 . '-*';
			$wildpart = $2;
			unless (defined $main::config{RRD}{$wildrrd}) {
				&error("get_rrd: can't find wild rrd for '$realrrd'");
				return ();
			}
		}
		else {
			&error("get_rrd: can't find wild rrd for '$realrrd'");
			return ();
		}
	}

	$extra = $main::config{RRD}{$wildrrd}{EXTRA};

	$fixedrrd = &to_filename($realrrd);

($wildrrd, $wildpart, $extra, $fixedrrd, $realrrd);
}

#------------------------------------------------------------- make_array ---
sub make_array {
	my ($string) = @_;
	my @array = ();

#	&debug("make_array: passed '$string'") if ($main::debug>2);
	while (length($string) > 0) {
		if ($string =~ /^'([^']+)'\s*(.*)/) {
			push @array, $1;
			$string = $2;
		}
		elsif ($string =~ /^"([^"]+)"\s*(.*)/) {
			push @array, $1;
			$string = $2;
		}
		elsif ($string =~ /^(\S+)\s*(.*)/) {
			push @array, $1;
			$string = $2;
		}
		else { &abort("make_array is broken; internal error"); }
		$string =~ s/^\s*//;
	}
#	&debug("make_array: returned:\n\t" . join("\n\t",@array) . "\n")
#		if ($debug>2);
@array;
}

#---------------------------------------------------------------- get_ip ---
sub get_ip {
	my ($hostname) = @_;
	my ($ip);

# Read the ip_cache if we haven't already
	unless (defined %main::ip_cache) {
		&read_ip_cache;
		$main::ip_cache_changed = 0;
	}

# Have we heard of this host?
	if (!defined $main::config{HOST}{$hostname}) {
		&debug("unknown host $hostname; attempting to continue") 
			if ($main::debug);
	}

# Have we got its IP number already?
	if (defined $main::ip_cache{HOST}{$hostname}) {
		$ip = $main::ip_cache{HOST}{$hostname};
		&debug("get_ip: got ip from cache: $hostname is $ip")
			if ($main::config_debug);
	}

# Is the IP number defined (old-style) on the host?  Cache it.
	elsif (defined $main::config{HOST}{$hostname}{IP}) {
		$ip = $main::config{HOST}{$hostname}{IP};
		$main::ip_cache{HOST}{$hostname} = $ip;
		$main::ip_cache{IP}{$ip} = $hostname;
		$main::ip_cache_changed = 1;
		&debug("get_ip: got ip from config: $hostname is $ip")
			if ($main::config_debug);
	}

# Look it up.
	else {
		$ip = gethostbyname($hostname);
		if (defined $ip) {
			$ip = inet_ntoa($ip);
			$main::ip_cache{HOST}{$hostname} = $ip;
			$main::ip_cache{IP}{$ip} = $hostname;
			$main::ip_cache_changed = 1;
			&debug("get_ip: got ip from gethostbyname: $hostname is $ip")
				if ($main::config_debug);
		}
	}

	unless (defined $ip) {
		&error("get_ip: couldn't find IP number for $hostname");
	}
$ip;
}

#--------------------------------------------------------- testout ---
sub testout {
	my ($msg) = @_;
	print STDERR "TEST: $msg\n";
}

#--------------------------------------------------------- make_a_dir ---
sub make_a_dir {
	my ($dir) = @_;

	if (defined $main::testonly and $main::testonly) {
		&testout("make_a_dir $dir not done; test-mode");
		return 1;
	}

	if (mkdir $dir, 0775) {
		return 1;
	}
	else {
		&error("make_a_dir: can't mkdir $dir: $!");
		return 0;
	}
}

#---------------------------------------------------------- put_status ---
sub put_status {
	my ($host, $file, $value) = @_;
	my $dir;
	
	if (defined $main::testonly and $main::testonly) {
		&testout("put_status($host, $file, $value) skipped; test-mode");
		return 0;
	}
	$dir .= $main::config{DATADIR} . '/' . $host;
	unless (-d $dir) { &error("put_status: directory $dir is missing; skipped"); return; }

	$file = $dir . '/' . $file;
	if (defined $value) {
		open (STATUS, ">$file") or 
			(&error("put_status: Can't open status-file $file: $!") and return);
		print STATUS $value;
		close(STATUS);
	}
	else {
		unlink $file; # and I don't care if unlink fails
	}

}

#--------------------------------------------------------- get_status ---
sub get_status {
	my ($host, $file) = @_;
	my ($value, $stale);
	$file = $main::config{DATADIR} ."/$host/$file";

	if (!-f $file) { $value =  'MISSING'; $stale=0; }
	else {
		if (((-M $file)*24*60*60) > $main::config{STALETIME}) {
			$stale = (-M $file)*24*60*60;
		}
		else { $stale = 0; }
		if( open (STATUS, "<$file")) {
			$value = <STATUS>;

# This can happen if you run graph-writer while a collector is updating a
# status file.
			if (defined $value) { chomp $value; }
			else { $value = 'EMPTY'; }
			close (STATUS);
		}
		else {
			&error("get_status: can't open $file: $!");
			$value = 'ERROR';
		}
	}
	if (wantarray) { return ($value, $stale); }
	else { return ($stale) ? $value.' (STALE)' : $value; }
}

#------------------------------------------------------------- to_filename ---
sub to_filename {
	my ($name) = @_;
	
	if (defined $name) {
		$name =~ tr#/A-Z :#-a-z_.#;
		$name =~ tr#!'"?<>\[\]\{\}\\\|/\$\~\^\&\*\(\)##d; # we don't need no stinkin' grot
	}
$name;
}

#--------------------------------------------------------------- siunits ---
# Make big numbers fit into smaller, more comprehensible display
sub siunits {
	my ($num) = @_;
	my $string;

	my ($whole, $fraction) = split('\.',$num);
	if (defined $fraction) { $num = $whole .'.'. substr($fraction,0,2); }
	else { $num = $whole; }

	if ($num >= 1000000000000) { $string = int($num/100000000000+.5)/10 . 'T'; }
	elsif ($num >= 1000000000) { $string = int($num/100000000+.5)/10 . 'G'; }
	elsif ($num >= 1000000) { $string = int($num/100000+.5)/10 . 'M'; }
	elsif ($num >= 1000) { $string = int($num/100+.5)/10 . 'K'; }
	else { $string = $num; }
$string;
}

#--------------------------------------------------------------- timestamp ---
sub timestamp {
	my ($secs) = @_;
	my $string;

	unless (defined $secs) { $secs = time; }
	my ($sec, $min, $hour, $mday, $mon, $year) = localtime($secs);
	$string = sprintf("%04d-%02d-%02d %02d:%02d:%02d",
		$year+1900, $mon+1, $mday, $hour, $min, $sec);
$string;
}

#------------------------------------------------------------- sec_to_dhms ---
sub sec_to_dhms {
        my ($secs) = @_;
	unless (defined $secs) { $secs = 0; }
        my ($string, $sec, $min, $hour, $day, $temp);

        $sec = int($secs % 60);
        $temp = int(($secs - $sec) / 60);
        $min = $temp % 60;
        $temp = ($temp - $min) / 60;
        $hour = $temp % 24;
	$day = ($temp - $hour) / 24;
	$string = sprintf("%dd%02d:%02d:%02d", $day, $hour, $min, $sec);

$string;
}

#----------------------------------------------- logit ---
sub logit {
	my ($class, $host, $rrdname, $varname, $value, $msg) = @_;
	my $now = time;
	my ($mday, $mon) = (localtime($now))[3,4];
	++$mon;
	if ($mon < 10) { $mon = '0' . $mon; }
	if ($mday < 10) { $mday = '0' . $mday; }

	unless (-d $main::config{LOGDIR}) {
		&error("logit: log directory '$main::config{LOGDIR}' doesn't exist");
		return;
	}

	unless (defined $main::log_opened and $main::log_opened) {
		my ($logfile) = $main::config{LOGDIR} .'/'. $mon . $mday .'.log';
		if ($logfile =~ /^(.*)$/) {
			$logfile = $1; # untaint it
		}
		open (LOG, ">>$logfile") or
			(&error("logit: can't open log $logfile: $!") and return);
		$main::log_opened = 1;
	}

	if (!defined $class or $class eq '') { $class = '-'; }
	if (!defined $host or $host eq '') { $host = '-'; }
	if (!defined $rrdname or $rrdname eq '') { $rrdname = '-'; }
	if (!defined $varname or $varname eq '') { $varname = '-'; }
	if (!defined $value or $value eq '') { $value = '-'; }
	if (!defined $msg or $msg eq '') { $msg = '-'; }

	print LOG &timestamp($now) .' '. $class .' '. $host .' '. $rrdname .
		' '. $varname .' '. $value .' '. $msg ."\n";
	&debug("logged $now $class $host $rrdname $varname $value $msg")
		if ($main::debug);

# What's going on with the garbage in the logs?
	if (-f $main::config{'TEMPDIR'}.'/remstatslog.log') {
		open (LOGLOG, ">>$main::config{'TEMPDIR'}/remstatslog.log") 
			or die "$main::prog: can't open /tmp/remstatslog.log: $!\n";
		print LOGLOG $main::prog .': '. &timestamp($now) .' '. $class 
			.' '. $host .' '. $rrdname .
			' '. $varname .' '. $value .' '. $msg ."\n";
		close (LOGLOG);
	}
}

#------------------------------------------------------ log_reboot ---
sub log_reboot {
	my ($host, $uptime, $who) = @_;

	my ($old_uptime) = &get_status( $host, 'UPTIME');
	&debug("log_reboot: host=$host, uptime=$uptime, old=$old_uptime")
		if ($main::debug>2);
	if ($uptime =~ /^(\d+)$/) { $uptime = $1; }
	else {
		&error("log_reboot: bad uptime for $host: '$uptime'");
		return;
	}

	if ($old_uptime eq 'MISSING') {
		&logit( 'NEWHOST', $host, undef, undef, undef, "detected by $who");
	}
	elsif ($old_uptime !~ /^\d+$/) {
		&error("bad old uptime for $host: '$old_uptime'");
		return;
	}
# This is almost guaranteed to cause multiple log entries for one re-boot, reverting to old
#	elsif ( $uptime < $main::config{UPTIMEALERT} ) { #SRF
# This one can miss multiple re-boots if they occur within the sample interval, but it
# will note at least one of these, which is the main thing.
	elsif ($old_uptime > $uptime) {
		my $boottime = time - $uptime;
		&logit( 'BOOT', $host, undef, undef, $boottime, 'at '. &timestamp($boottime));
	}
}

#--------------------------------------------------------- get_uphosts ---
sub get_uphosts {
	my $file = $main::config{'TEMPDIR'} .'/uphosts';
	my %uphosts = ();
	
	open (UP, "<$file") or do {
		&error("can't open $file: $!; not using uphosts");
		$main::use_uphosts = 0;
		return;
	};
	while (<UP>) {
		chomp;
		$uphosts{$_} = 1;
	}
	close (UP);

%uphosts;
}

#-------------------------------------------------- add_group_if_missing ---
sub add_group_if_missing {
	my ($newgroup) = @_;

	my $file = $main::config_dir .'/groups';
	open (GROUPS, "+<$file") or &abort("can't open $file: $!");
	while (<GROUPS>) {
		chomp;
		next if (/^#/ or /^\s*$/);
		s/^\s+//;
		s/\s+$//;
		if ($newgroup eq $_) {
			close (GROUPS);
			return;
		}
	}
	print GROUPS "$newgroup\n";
	close (GROUPS);
}

#------------------------------------------------------ list_files ---
# list all the non-dot files in the specified directory
sub list_files {
	my ($dir, $pattern) = @_;
	my $file;
	my @files = ();
	&debug("list_files: dir=$dir". ((defined $pattern) ? ", pattern=$pattern" : '')) 
		if ($main::config_debug);

# In case some-one specified a wildcard, like a glob arg
	if ($dir =~ m'(.*)/\*$') { $dir = $1; }

	opendir(DIR, $dir) or &abort("can't opendir $dir: $!");
	while ($file = readdir(DIR)) {
		&debug("  file $file") if ($main::config_debug);
		next if ($file =~ /^\./ or $file =~ /^IGNORE/ or
			$file =~ /\~$/);
		if (defined $pattern and $file =~ /$pattern/) {
			push @files, $dir .'/'. $file;
			&debug("  keeping it") if ($main::config_debug);
		}
		elsif (!defined $pattern) {
			push @files, $dir .'/'. $file;
			&debug("  keeping it") if ($main::config_debug);
		}
	}
	closedir(DIR);
	@files = sort @files;

@files;
}

#------------------------------------------------- read_ip_cache ---
sub read_ip_cache {
	my ($cache_file, $host, $ip);

# Create the cache if it's not there
	$cache_file = $main::config{DATADIR} .'/IP_CACHE';
	unless (-f $cache_file or -l $cache_file) {
		&debug("read_ip_cache: creating ip cache") if ($main::debug>3);
		open (CACHE, ">$cache_file") or &abort("can't open $cache_file: $!");
		close(CACHE);
		%main::ip_cache = ();
		return;
	}

# Read it
	&debug("read_ip_cache: reading file") if ($main::debug>3);
	open (CACHE, "+<$cache_file") or &abort("can't open $cache_file: $!");
	while (<CACHE>) {
		chomp;
		next if (/^\s*#/ or /^\s*$/);
		($host, $ip) = split(' ', $_);
		$host = lc $host;
		&debug("  $host $ip") if ($main::debug>3);
		$main::ip_cache{HOST}{$host} = $ip;
		$main::ip_cache{IP}{$ip} = $host;
	}
	$main::ip_cache{HOST}{'_remstats_'} = '127.0.0.1';
# purposefully not closed
}

#------------------------------------------------ write_ip_cache ---
sub write_ip_cache {
	return unless ($main::ip_cache_changed);
	my $cache_file = $main::config{DATADIR} .'/IP_CACHE';

# Make sure we pick up any other updates
	&read_ip_cache;
	flock( CACHE, LOCK_EX) or &abort("can't lock $cache_file: $!");
	seek( CACHE, 0, 0) or &abort("can't rewind $cache_file: $!");

	print CACHE "# updated by $main::prog at ". scalar(localtime) ."\n\n";
	foreach my $host (sort keys %{$main::ip_cache{HOST}}) {
		next if ($host eq '_remstats_');
		print CACHE $host .' '. $main::ip_cache{HOST}{$host} ."\n";
	}
	close(CACHE);
}

#------------------------------------------------ m_or_km_to_km ---
sub m_or_km_to_km {
	my ($string) = @_;
	my ($number, $units, $km);

	if ($string =~ /^(\d+\.?|\.\d+|\d+\.\d+)\s*(m|km)/i) {
		$number = $1;
		$units = lc $2;
		if ($units eq 'km') { $km = $number; }
		elsif ($units eq 'm') { $km = $number / 1000; }
		else {
			&error("m_or_km_to_km: bad string '$string'; returning undef");
		}
	}
	else {
		$km = $string + 0;
	}
$km;
}

#------------------------------------------------------ make_lockfile ---
sub make_lockfile {
	my ($lockfile, $max_stale_time) = @_;

	unless (defined $lockfile) {
		&abort("make_lockfile called with undefined name for file");
	}

# Break stale locks
	if (defined $max_stale_time and -e $lockfile) {
		if ((-M $lockfile)*24*60*60 >$max_stale_time) {
			&error("breaking stale lockfile $lockfile");
			unlink $lockfile or &abort("can't unlink $lockfile: $!");
		}
	}

# Make a temporary lock
	my $tmplock = $lockfile .'.'. $$;
	open (LOCK, ">$tmplock") or do {
		&error("make_lockfile: can't open $tmplock: $!");
		return 0;
	};
	print LOCK $$, "\n";
	close (LOCK);

# Lock by linking the temp file to the lockfile
	link $tmplock, $lockfile or do {
		&error("make_lockfile: can't link $tmplock to $lockfile: $!");
		unlink $tmplock;
		return 0;
	};
	unlink $tmplock;
1;
}

#------------------------------------------------------ check_collect_time ---
# check whether it's time to collect data for a specific rrd #TVE
sub check_collect_time {
	my ($host, $wildrrd, $fixedrrd) = @_;
	my ($rrdfile, $timelast, $err, $timenow, $rrd_step);

# First get the RRDfilename
	$rrdfile = $main::config{DATADIR}.'/'.$host.'/'.$fixedrrd.'.rrd';
	unless (-f $rrdfile) {
		&error("missing RRD $rrdfile");
		return 0;
	}

# Now do a last to get the last update time
	$timelast = RRDs::last $rrdfile;
	$err = RRDs::error();
	if ($err) {
		&error("error reading RRD $rrdfile: $err");
		return 0;
	}

# Should we collect now, or the next time? We know that RRDTool
# wants its data when (time mod step) == 0. So each time we
# cross such a boundary we take a sample.
# What time is it now?
	$timenow = int(time);

# What's the RRD's step?
	$rrd_step = $main::config{RRD}{$wildrrd}{STEP};
	$rrd_step = 300 unless defined $rrd_step; # just in case...

# Take a sample if we crossed an RRD sample boundary since we
# last took a sample
	&debug("  RRD $fixedrrd($wildrrd): last=$timelast" .
	       " rrd=" . (int($timenow/$rrd_step) * $rrd_step) . " now=$timenow" .
		   " step=$rrd_step");
	return int($timenow/$rrd_step) != int($timelast/$rrd_step);
}

#------------------------------------------------------ do_escapes ---
sub do_escapes {
	my $string = shift @_;

	$string =~ s/\\n/\n/g;

	return $string;
}

#-------------------------------------------------------- show_uptime ---
sub show_uptime {
	my $uptime = shift @_;
	my $html;

	if (defined $uptime) {
		$html = &sec_to_dhms($uptime);
		if ($uptime < $main::config{MINUPTIME}) {
			$html = '<span style="background-color: red">' . $html . '</span>';
		}
		$html .= ' (up at ' . &timestamp(time() - $uptime) . ')';
	}
	else { $html = 'unknown'; }

	return $html;
}

#----------------------------------------------------------- EOF ---

# - - -   Say good-night, Dick   - - -

1;

