#!/usr/bin/perl -Tw

# Copyright 1999, 2000, 2001 (c) Thomas Erskine <thomas.erskine@sourceworks.com>
# See the COPYRIGHT file with the distribution.

# ping.cgi - let people ping the monitored hosts
# $Id: ping.cgi.in,v 1.7 2001/08/28 15:22:24 remstats Exp $

# - - -   Configuration   - - -

# What is this program called, for file-names and error-messages.
$main::prog = 'ping.cgi';
# How to invoke ping
$main::ping = '/usr/lib/remstats/bin/multiping -i 1 -s 80 -c 5 %s';
# So -T will stop whinging.
$ENV{PATH} = '/usr/local/bin:/usr/bin:/usr/local/sbin:/usr/sbin';

# Debugging anyone?
$main::debug = 0;

# - - -   Version History   - - -

(undef, $main::version) = split(' ', '$Revision: 1.7 $');

# - - -   Setup   - - -

$| = 1; # no buffering please

use lib '.', '/usr/lib/remstats/lib';
require "cgistuff.pl";

# Initialize some useful variables
%main::R = &cgi_request;
%ENV = ();
&cgi_sendheaders('Description: $main::prog version $main::version');
$main::url = 'http://' . &cgi_var("SERVER_NAME") . ':' . &cgi_var('SERVER_PORT')
	. &cgi_var('SCRIPT_NAME');

print &cgi_fmtrequest(%main::R) if ($main::debug);

# Clear the environment

# - - -   Main Line   - - -

my $host;
if (defined $main::R{'host'} and $main::R{'host'} =~ /^([-0-9a-zA-Z.]+)$/) {
	$host = $1;
}
elsif (defined $main::R{'host'}) {
	&abort("bad host field: $main::R{'host'}");
}
else {
	print <<"EOD_FORM";
<HTML>
<HEAD>
<TITLE>$main::prog</TITLE>
</HEAD>
<BODY>
<H1>$main::prog (version $main::version)</H1>
<FORM METHOD="POST" ACTION="$main::url">
Ping host: <INPUT NAME="host" SIZE=20> <INPUT TYPE="SUBMIT" VALUE="Do it">
</FORM>
</BODY>
</HTML>
EOD_FORM
	exit 0;
}

$main::ping = sprintf($main::ping, $host);

print <<"EOD_HEADER";
<HTML>
<HEAD>
<TITLE>$main::prog $host</TITLE>
</HEAD>
<BODY>
<H1>$main::prog (version $main::version) $host</H1>
<FORM METHOD="POST" ACTION="$main::url">
Ping Host: <INPUT NAME="host" SIZE=20 VALUE="$host"> <INPUT TYPE="SUBMIT" VALUE="Do it">
</FORM>
<HR>
<PRE>
EOD_HEADER
	open (PIPE, "$main::ping|") or &abort("Can't start ping: $!");
	while (<PIPE>) {
		print $_;
	}
	close (PIPE);
	print <<"EOD_FOOTER";
</PRE>
<HR>
<A HREF="$main::url?$host">Do that one again</A>
EOD_FOOTER

0;

sub abort {
	my $msg = join('', @_);
	print <<"EOD_ABORT";
<HTML>
<HEAD><TITLE>$main::prog Abort</TITLE></HEAD>
<BODY>
<H1>$main::prog (version $main::version) Abort</H1>
$msg
</BODY>
</HTML>
EOD_ABORT
	exit 1;
}

sub error {
	my $msg = join('', @_);
	&abort( $msg);
}
